
###############################################################################
# Sources From LigaScript                                                     #
###############################################################################
# LigaScript: Online Ligaverwaltung                                           #
#                                                                             #
# Version:        LigaScript Full Version 2.0.1 BETA!                         #
# First-Released: August 1999                                                 #
# Distributed by: http://leagues.ihoax.de                                     #
# =========================================================================== #
# Copyright (c) 2000-2003 Joerg Nass (www.ihoax.de) - All Rights Reserved.    #
# Software by: Joerg Nass                                                     #
# Kontaktinformationen und weiteres sind jeweils auf den angebenen            #
# Homepages zu finden!                                                        #
###############################################################################
#  ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!!                #
#  Bitte den Disclaimer und die Nutzungsbedingungen in der Datei              #
#  LSCConfig.pm lesen!                                                        #
#                                                                             #
###############################################################################


sub _MSGForderungenZwischenTeamATeamB {
	$Team1 = $LSC{MySQL}->quote(shift || 0);
	$Team2 = $LSC{MySQL}->quote(shift || 0);

	my $sth = $LSC{MySQL}->prepare("select ID from lsc_games_waiting_daten where League=$LSC{League} and
						((F_Team1=$Team1 and F_Team2=$Team2) or (F_Team2=$Team1 and F_Team1=$Team2)) Limit 1");
	if ($sth->execute()) {
		my $ref = $sth->fetchrow_arrayref();
		$sth->finish();
		if ($ref && $ref->[0] > 0) {
			return $ref->[0];
		}
	}
	return 0;
}
sub ForderungVorhanden {
	my $wid = shift || return undef;

	$wid = $LSC{MySQL}->quote($wid);
	my $sth = $LSC{MySQL}->prepare("select count(*) from lsc_games_waiting_daten where ID=$wid and League=$LSC{League}");
	if ($sth->execute()) {
		my $ref = $sth->fetchrow_arrayref();
		$sth->finish();
		if ($ref && $ref->[0]) {
			return 1;
		}
	}
	return undef;
}
sub ForderungLaden {
	my $wid = shift || return undef;

	$wid = $LSC{MySQL}->quote($wid);

	my $sth = $LSC{MySQL}->prepare("select * from lsc_games_waiting_daten where ID=$wid");
	if ($sth->execute()) {
		my $ref = $sth->fetchrow_hashref();
		$sth->finish();
		if ($ref) {
			($ref->{F_Teamname1}, undef) = TeamnameAndUserFromTeamID($ref->{F_Team1});
			($ref->{F_Teamname2}, undef) = TeamnameAndUserFromTeamID($ref->{F_Team2});
			$ref->{Liganame} = LigaName($ref->{League});
			$ref->{Confirm} = {};
			$ref->{GameDaten} = {};
			if ($ref->{Date}) {
				$ref->{OriDate} = $ref->{Date};
				$ref->{Date} =~ /(\d\d\d\d).(\d\d).(\d\d) (\d+\:\d+)\:.*/;
				if ($1 +$2 +$3 > 0) {
					# Ergebnis wurde eingetragen
					$ref->{Date} = "$3.$2.$1 $4";
					
					# wer hat besttigt
					my %confirm = ();
					my %game = ();
					my $sth = $LSC{MySQL}->prepare("select Team, Confirm, Points, PPoints1, PPoints2, LP, Map, Won, Lost, Draw, Home, Vote from lsc_games_waiting where WaitingID=$wid");
					if ($sth->execute()) {
						while (my $ref2 = $sth->fetchrow_arrayref()) {
							$confirm{$ref2->[0]} = $ref2->[1];
							$game{$ref2->[0]}{Team}		= $ref2->[0];	
							my $pos = 2;
							$game{$ref2->[0]}{Points}	= $ref2->[$pos++];	
							$game{$ref2->[0]}{PPoints1} = $ref2->[$pos++];	
							$game{$ref2->[0]}{PPoints2} = $ref2->[$pos++];	
							$game{$ref2->[0]}{LP}		= $ref2->[$pos++];	
							$game{$ref2->[0]}{Map}		= $ref2->[$pos++];	
							$game{$ref2->[0]}{Won}		= $ref2->[$pos++];	
							$game{$ref2->[0]}{Lost}		= $ref2->[$pos++];	
							$game{$ref2->[0]}{Draw}		= $ref2->[$pos++];	
							$game{$ref2->[0]}{Home}		= $ref2->[$pos++];	
							$game{$ref2->[0]}{Vote}		= $ref2->[$pos++];	
							if ($ref->{F_Team1} == $ref2->[0]) {
								$game{$ref2->[0]}{Name} = $ref->{F_Teamname1};
							} elsif ($ref->{F_Team2} == $ref2->[0]) {
								$game{$ref2->[0]}{Name} = $ref->{F_Teamname2};
							} else {
								($game{$ref2->[0]}{Name}, undef) = TeamnameAndUserFromTeamID($ref2->[0]);
							}
						}
						$sth->finish();
					}
					if (%confirm) {
						$ref->{Confirm} = \%confirm;
					}
					if (%game) {
						$ref->{GameDaten} = \%game;
					}
				} else {
					$ref->{Date} = "";
				}
			}
			$ref->{F_Date_Ori} = $ref->{F_Date};
			if ($ref->{F_Date}) {
				$ref->{F_Date} =~ /(\d\d\d\d).(\d\d).(\d\d) (\d+\:\d+)\:.*/;
				if ($1 +$2 +$3 > 0) {
					$ref->{F_Date} = "$3.$2.$1 $4";
				} else {
					$ref->{F_Date} = "";
				}
			}

			if ($ref->{F_ChangeDate}) {
				$ref->{F_ChangeDate} =~ /(\d\d\d\d).(\d\d).(\d\d) (\d+\:\d+)\:.*/;
				if ($1 +$2 +$3 > 0) {
					$ref->{F_ChangeDateShow} = "$3.$2.$1 $4";
				} else {
					$ref->{F_ChangeDateShow} = "";
				}
			}

		}
		return $ref;
	}
	return undef;
}
sub _Ergebnisse_PunkteDefinition_Laden {
		if ($LSC{LeagueData}{NewGamePoints}) {
			return 1;
		}
		my $sth = $LSC{MySQL}->prepare("SELECT * from lsc_leagues_points where League=$LSC{League}");
		if ($sth->execute()) {
			my $ref = $sth->fetchrow_hashref();
			$sth->finish;

			if ($ref) {
				$LSC{LeagueData}{NewGamePoints} = {
					Won=>[$ref->{Won1}, $ref->{Won2}],
					Lost=>[$ref->{Lost1}, $ref->{Lost2}],
					Draw=>[$ref->{Draw1}, $ref->{Draw2}],
					Draws=>$ref->{Draws},
					ForceDraws=>$ref->{ForceDraws},
					Elo1=>$ref->{Elo1},
					Elo2=>$ref->{Elo2},
					EloFunction=>$ref->{EloFunction},
					StartPoints=>$ref->{StartPoints},
					};

					$sth = $LSC{MySQL}->prepare("SELECT * FROM lsc_leagues_points_bonus WHERE League=$LSC{League}");
					$sth->execute();
					my $bonus = $sth->fetchrow_hashref();
					$sth->finish;
					if ($bonus) {
						$LSC{LeagueData}{NewGamePoints}{Bonus} = 1;
						if ($bonus->{'WonDiff1'}) {
							$LSC{LeagueData}{NewGamePoints}{Bonus}{Won}{+PunkteDiff} = [$bonus->{'WonDiff1'}, $bonus->{'WonDiff2'}||0];
						}
						if ($bonus->{'LostDiff'}) {
							$LSC{LeagueData}{NewGamePoints}{Bonus}{Lost}{-PunkteDiff} = [$bonus->{'LostDiff'}];
						}
						if ($bonus->{'TopPos'} && $bonus->{'TopBonus'}) {
							$LSC{LeagueData}{NewGamePoints}{Bonus}{Won}{Top} = [$bonus->{'TopPos'}, $bonus->{'TopBonus'}];
						}
						if ($bonus->{'WonRangFaktor'}) {
							$LSC{LeagueData}{NewGamePoints}{Bonus}{Won}{+Rang} = [$bonus->{'WonRangFaktor'}];
						}
						if ($bonus->{'LostRangFaktor'}) {
							$LSC{LeagueData}{NewGamePoints}{Bonus}{Lost}{-Rang} = [$bonus->{'LostRangFaktor'}];
						}
					}
				return 1;
			}

		} 
		return undef;
}


1