
###############################################################################
# Sources From LigaScript                                                     #
###############################################################################
# LigaScript: Online Ligaverwaltung                                           #
#                                                                             #
# Version:        LigaScript Full Version 2.1.0	                              #
# First-Released: August 1999                                                 #
# Distributed by: http://www.scroax.net                                       #
# =========================================================================== #
# Copyright (c) 2004 Joerg Nass (www.scroax.net) - All Rights Reserved.	      #
# Software by: Joerg Nass                                                     #
# Kontaktinformationen und weiteres sind jeweils auf den angebenen            #
# Homepages zu finden!                                                        #
###############################################################################
#  ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!!                #
#  Bitte den Disclaimer und die Nutzungsbedingungen in der Datei              #
#  LSCConfig.pm lesen!                                                        #
#                                                                             #
###############################################################################


sub StrafpunkteAnzeigen {
	print '<div class=Headline>'.$LSC{TEXT}{Strafpunkte}[0].'</div>';
	if (!$LSC{Strafpunkte} || !$LSC{League}) {
		print $LSC{TEXT}{ERROR}[9].br;
		return;
	}
	
	my ($Action, $Start) = @_;
	if ($Action) {
		if ($Action eq "edit" && $LSC{Admin}) {
			StrafpunkteNeuEdit($Start);
			return;
		} elsif ($Action eq "new" && $LSC{Admin}) {
			StrafpunkteNeuEdit($Start, 1);
			return;
		} elsif ($Action eq "deleteold" && $LSC{Admin}) {
			my $sth = $LSC{MySQL}->do("delete from lsc_leagues_strafpunkte where League=$LSC{League} and EndDate < now() and EndDate > 0");
			print "Alte Strafen gelscht!".br.br;
		}
		$Start = 0;
	}
	if (!$Start) {
		$Start = 0;
	} elsif ($Start =~/[^0-9]/) {
		$Start = 0;
	}
	my $Ende = $Start +20;
	
	my $sth = $LSC{MySQL}->prepare("SELECT id,  League,  TeamUser,  TeamUserID,  GameID,  ShortInfo,  FullInfo,  DATE_FORMAT(InsertDate,'%e.%m.%Y'),  DATE_FORMAT(EndDate,'%e.%m.%Y'),  PrivatePoints,  LeaguePoints,  LeagueWon,  LeagueLost,  AdminID from lsc_leagues_strafpunkte where League=? and (EndDate > now() or EndDate=0) order by InsertDate desc limit $Start, $Ende");
	unless ($sth->execute($LSC{League})) {
		print $LSC{TEXT}{Strafpunkte}[1].br;
		return;
	}
	my $Template = TemplateLoad1($LSC{Templates}{'StrafpunkteLiga'});
	unless ($Template) {
		print "Konnte Template nicht laden! ($!)".br;
		return;
	}

	if ($sth->rows) {
		print TemplateMaker($Template->{'Headline'}, {});
	}
	while (my $ref = $sth->fetchrow_arrayref()) {
		my $values = {};
		$values->{"LSC-ID"} = $ref->[0];
		if ($ref->[2] == 2) {
			#Team
			my ($Name, undef) = UserNameUndStatusVonID($ref->[3]);
			$values->{"LSC-Name"} = UserLink($Name, $ref->[3]);
		} elsif ($ref->[2] == 1) {
			#Team
			my ($Name, undef) = TeamnameAndUserFromTeamID($ref->[3]);
			$values->{"LSC-Name"} = TeamLink({Name=>$Name, ID=>$ref->[3], HideVote=>1, League=>$ref->[1]});
		} else {
			$values->{"LSC-Name"} = "unknown";
		}

		$values->{"LSC-Date"} = $ref->[7];
		$values->{"LSC-EndDate"} = $ref->[8];
		if ($ref->[8] eq '0.00.0000') {
			$values->{"LSC-EndDate"} = $LSC{TEXT}{Strafpunkte}[6];
		}

		$values->{"LSC-ShortInfo"} = $ref->[5];
		$values->{"LSC-FullInfo"} = "";
		$values->{"LSC-FullInfo"} = "<b>Admin-Info: </b>".$ref->[6] if $LSC{Admin};

		#punish
		$values->{"LSC-Punish"} = "";
		if ($ref->[9]) {
			#Liga-Strafpunkte
			$values->{"LSC-Punish"} = $ref->[9]." ".$LSC{TEXT}{Strafpunkte}[2];
		} 
		if ($ref->[10]) {
			#Ligapunkte
			$values->{"LSC-Punish"} .= '<br>' if $values->{"LSC-Punish"};
			$values->{"LSC-Punish"} .= $ref->[10]." ".$LSC{TEXT}{Strafpunkte}[3];
		} 
		if ($ref->[11]) {
			#Sieg
			$values->{"LSC-Punish"} .= '<br>' if $values->{"LSC-Punish"};
			$values->{"LSC-Punish"} .= $ref->[11]." ".$LSC{TEXT}{Strafpunkte}[4];
		} 
		if ($ref->[12]) {
			#Niederlage
			$values->{"LSC-Punish"} .= '<br>' if $values->{"LSC-Punish"};
			$values->{"LSC-Punish"} .= $ref->[12]." ".$LSC{TEXT}{Strafpunkte}[5];
		} 
		
		if ($ref->[4]) {
			$values->{"LSC-Punish"} = RecapLink($ref->[1], $ref->[4], $values->{"LSC-Punish"});
		}
		$values->{"LSC-Punish"} = "?" unless $values->{"LSC-Punish"};

		$values->{"LSC-AdminLink"} = "";
		if ($ref->[13]) {
			my ($AdminName, undef) = UserNameUndStatusVonID($ref->[13]);
			$values->{"LSC-AdminLink"} = "".UserLink($AdminName, $ref->[13]);
		}

		if ($LSC{Admin}) {
			$values->{"LSC-Admin"} = ShowLink({Name=>"edit/delete", Script=>"$LSC{user_pl}", Action=>"Punish", Action2=>"edit", Special=>$ref->[0], League=>$ref->[1]});
		} else {
			$values->{"LSC-Admin"} = "";
		}
		print TemplateMaker($Template->{'Strafpunkte'}, $values);
	}
	if ($sth->rows) {
		print TemplateMaker($Template->{'Bottom'}, {});
		if ($Start > 0) {
			print ShowLink({Name=>"[start]", Script=>"$LSC{user_pl}", Action=>"Punish", Action2=>"", 	Special=>0, League=>$LSC{League}})."&nbsp;";
			print "&nbsp;".ShowLink({Name=>"&lt;=", Script=>"$LSC{user_pl}", Action=>"Punish", Action2=>"", 	Special=>(($Start - 20 > 0) ? ($Start-20) : 0), League=>$LSC{League}})."&nbsp;";
		}
		if ($sth->rows >= 20) {
			print "&nbsp;".ShowLink({Name=>"&gt;=", Script=>"$LSC{user_pl}", Action=>"Punish", Action2=>"", 	Special=>($Start +20), League=>$LSC{League}})."&nbsp;";
		}
	} else {
		print TemplateMaker($Template->{'empty'}, {});
	}
	$sth->finish;

	if ($LSC{Admin}) {
		print "<br><B>Admin:</B> verfallene Strafpunkte werden nicht mehr eingerechnet, aber nicht automatisch aus der bersicht gelscht. Verfallene Strafen werden auf den entsprechenden Teamseiten weiterhin angezeigt! Um diese Strafen auch aus den Teamseiten zu lschen hier klicken: ".ShowLink({Name=>"Verfallene Strafen lschen", Script=>"$LSC{user_pl}", Action=>"Punish", Action2=>"deleteold", Special=>"", League=>$LSC{League}}).br."Es folgt keine weitere Abfrage!".br;
	}
}

sub StrafpunkteNeuEdit {
	my $ID = shift;
	my $neu = shift;
	unless ($ID) {
		print $LSC{TEXT}{Strafpunkte}[7].br;
		return;
	}
	if ($q->param("change")) {
		my $EndDate = 0;
		if ($q->param("EndDate2") && $q->param("EndDate2")!~/[^0-9]/) {
			$EndDate = "date_add(now(), INTERVAL ".$q->param("EndDate2")." DAY)";
		} else {
			$EndDate = $LSC{MySQL}->quote($q->param("EndDate"));
		}
		my $sth = $LSC{MySQL}->prepare("update lsc_leagues_strafpunkte set GameID=?,  ShortInfo=?,  FullInfo=?,  InsertDate=now(),  EndDate=$EndDate,  PrivatePoints=?,  LeaguePoints=?,  LeagueWon=?,  LeagueLost=?,  AdminID=? where id=? and League=?");
		if ($sth->execute($q->param("GameID") || "", $q->param("ShortInfo") || "", $q->param("FullInfo") || "", $q->param("PrivatePoints") || "", $q->param("LeaguePoints") || "", $q->param("LeagueWon") || "", $q->param("LeagueLost") || "", $LSC{userid} || 0, 
					$ID, $LSC{League})) {
			print "Neue Werte gespeichert!".br;
		}
		$sth->finish;
	} elsif ($q->param("delete")) {
		my $sth = $LSC{MySQL}->prepare("delete from lsc_leagues_strafpunkte where id=? and League=?");
		if ($sth->execute($ID, $LSC{League})) {
			print "Strafpunkte gelscht!".br;
		}
		$sth->finish;
	}

	my $punish = [];
	
	if ($neu) {
		$punish = [0,0,0,0,0,"","",0,0,0,0,0,0];

		$punish->[1] = $LSC{League}; #liga
		$punish->[1] = $LSC{League}; #liga

		if ($ID=~/[^0-9\-]/) {
			print "Ungltige Team/User ID!".br;
			return;
		}

		if ($ID < 0) {
			# User 
			$punish->[2] = 2;
			$punish->[3] = -$ID;
		} elsif ($ID > 0) {
			# Team
			$punish->[2] = 1;
			$punish->[3] = $ID;
		} else {
			print "Ungltige Team/User ID!".br;
			return;
		}

	} 
	if ($q->param("save") && $neu) {
		my $EndDate = 0;
		if ($q->param("EndDate2") && $q->param("EndDate2")!~/[^0-9]/) {
			$EndDate = "date_add(now(), INTERVAL ".$q->param("EndDate2")." DAY)";
		} else {
			$EndDate = $LSC{MySQL}->quote($q->param("EndDate"));
		}
		my $sth = $LSC{MySQL}->prepare("insert into lsc_leagues_strafpunkte (League,  TeamUser,  TeamUserID,  GameID,  ShortInfo,  FullInfo, InsertDate,  EndDate,  PrivatePoints,  LeaguePoints,  LeagueWon,  LeagueLost,  AdminID) Values (?, ?, ?, ?, ?, ?, now(), $EndDate, ?, ?, ?, ?, ?)");
		
		if ($sth->execute($LSC{League}, $punish->[2], $punish->[3], $q->param("GameID") || "", $q->param("ShortInfo") || "", $q->param("FullInfo") || "", $q->param("PrivatePoints") || "", $q->param("LeaguePoints") || "", $q->param("LeagueWon") || "", $q->param("LeagueLost") || "", $LSC{userid} || 0)) {
			print "Neue Werte gespeichert!".br.br;
			$neu = 0;
			$ID = $sth->{mysql_insertid};
		} else {
			print "Strafpunkte konnten nciht gespeichert werden!".br.br;
		}
		$sth->finish;
	}
	
	unless ($neu){
		my $sth = $LSC{MySQL}->prepare("SELECT id,  League,  TeamUser,  TeamUserID,  GameID,  ShortInfo,  FullInfo,  DATE_FORMAT(InsertDate,'%e.%m.%Y'),  EndDate,  PrivatePoints,  LeaguePoints,  LeagueWon,  LeagueLost,  AdminID from lsc_leagues_strafpunkte where League=? and id=?");

		unless ($sth->execute($LSC{League}, $ID)) {
			print $LSC{TEXT}{Strafpunkte}[7].br;
			return;
		}	
		$punish = $sth->fetchrow_arrayref();
		$sth->finish;

		unless ($punish) {
			print $LSC{TEXT}{Strafpunkte}[7].br;
			return;
		}
	}
	print "Strafpunkte editieren:".br.br;

	my $Name = "";
	if ($punish->[2] == 2) {
		#Team
		($Name, undef) = UserNameUndStatusVonID($punish->[3]);
		$Name = "User: ".UserLink($Name, $punish->[3]);
	} elsif ($punish->[2] == 1) {
		#Team
		($Name, undef) = TeamnameAndUserFromTeamID($punish->[3]);
		$Name = "Team: ".TeamLink($Name, $punish->[3]);
	} else {
		$Name = "unknown";
	}
	print $q->start_form('post',"$scriptname?League=$LSC{League}&Action=$LSC{Action}&Action2=$LSC{Action2}&special=$LSC{special}");
	print "<table>";
	print "<tr><td width=150><I>Name:</I></td><td>$Name</td></tr>";
	
	$q->delete("ShortInfo");
	print "<tr><td><I>Public Info:</I></td><td>".$q->textfield("ShortInfo", $punish->[5], 40)."</td></tr>";
	print "<tr><td></td><td>Diese Nachricht ist fr jeden sichtbar.</td></tr>";
	print "<tr><td>&nbsp;</td></tr>";

	$q->delete("FullInfo");
	print "<tr><td><I>Admin Info:</I></td><td>".$q->textarea("FullInfo", $punish->[6], 5, 40)."</td></tr>";
	print "<tr><td></td><td>Hier knnen weitere Informationen oder Begrndungen fr die Strafpunkte gespeichert werden. Dieser Text ist nur fr LigaAdmins dieser Liga sichtbar.</td></tr>";
	print "<tr><td>&nbsp;</td></tr>";

	print "<tr><td><I>Date:</I></td><td>".$punish->[7]."</td></tr>";
	print "<tr><td></td><td>Das Datum wird automatisch auf das aktuelle Datum beim speichern gesetzt.</td></tr>";
	print "<tr><td>&nbsp;</td></tr>";
				
	$q->delete("EndDate");
	print "<tr><td><I>End-Date:</I></td><td>".$q->textfield("EndDate", $punish->[8], 12)."</td></tr>";
	print "<tr><td></td><td>Das aktuell gewhlte Datum, an dem die Strafe verfllt. 0000-00-00 entspricht einer Strafe, die nie verfllt. Format: YYYY-MM-DD !!!</td></tr>";
	print "<tr><td>&nbsp;</td></tr>";
	$q->delete("EndDate2");
	print "<tr><td><I>verfllt in X Tagen:</I></td><td>".$q->textfield("EndDate2", "0", 5)." Tage</td></tr>";
	print "<tr><td></td><td>Wird hier ein Wert ungleich 0 eingetragen, so verfllt die Strafe in den angebene Tagen, ab heute.</td></tr>";
	print "<tr><td>&nbsp;</td></tr>";

	$q->delete("GameID");
	print "<tr><td><I>GameID:</I></td><td>".$q->textfield("GameID", $punish->[4], 5)."</td></tr>";
	print "<tr><td></td><td>Hier kann eine GameID eines Ergebnisses eingetragen werden, zu dem z.b. die Strafpunkte vergeben wurden.</td></tr>";
	print "<tr><td>&nbsp;</td></tr>";

	print "<tr><td><B><U><I>Strafen:</I></U></B></td><td></td></tr>";

	$q->delete("PrivatePoints");
	print "<tr><td><I>".$LSC{TEXT}{Strafpunkte}[2]."</I></td><td>".$q->textfield("PrivatePoints", $punish->[9], 5)."</td></tr>";
	print "<tr><td></td><td>Persnliche Strafpunkte fr das Team oder den User. z.B. kann in den Regeln festgelegt werden, dass es fr verschiedene Aktionen Strafpunkte gibt und das bei X Punkten pro Team/User dieser aus der Liga ausgeschlossen wird. Auf den Teamseiten werden entsprechene Strafpunkte aufgefhrt. Diese Strafpunkte beeinflussen aber nicht die in der Liga vergeben Ligapunkte.</td></tr>";
	print "<tr><td>&nbsp;</td></tr>";

	$q->delete("LeaguePoints");
	print "<tr><td><I>".$LSC{TEXT}{Strafpunkte}[3]."</I></td><td>".$q->textfield("LeaguePoints", $punish->[10], 5)."</td></tr>";
	print "<tr><td></td><td>Die angegeben Punkte werden zu den Ligapunkten addiert. Fr eine Strafe muss also ein negativer Wert, z.B. -10, angegeben werden!</td></tr>";
	print "<tr><td>&nbsp;</td></tr>";

	$q->delete("LeagueWon");
	print "<tr><td><I>".$LSC{TEXT}{Strafpunkte}[4]."</I></td><td>".$q->textfield("LeagueWon", $punish->[11], 5)."</td></tr>";
	print "<tr><td></td><td>Die angegeben Punkte werden zu den Siegen addiert. Fr eine Strafe muss also ein negativer Wert, z.B. -10, angegeben werden!</td></tr>";
	print "<tr><td>&nbsp;</td></tr>";

	$q->delete("LeagueLost");
	print "<tr><td><I>".$LSC{TEXT}{Strafpunkte}[5]."</I></td><td>".$q->textfield("LeagueLost", $punish->[12], 5)."</td></tr>";
	print "<tr><td></td><td>Die angegeben Punkte werden zu den Niederlagen addiert.</td></tr>";
	print "<tr><td>&nbsp;</td></tr>";

	print "</table>";
	if ($neu) {
		print $q->hidden("save", 1).$q->submit("save").$q->end_form();
	} else {
		print $q->hidden("change", 1).$q->submit("change").$q->end_form();
		print $q->start_form('post',"$scriptname?League=$LSC{League}&Action=$LSC{Action}&Action2=$LSC{Action2}&special=$LSC{special}");
		print $q->hidden("delete", 1).$q->submit("delete").$q->end_form();
	}
}
sub StrafpunkteTeamLiga {
	#nur noch nicht verfallene Strafpunkte zhlen
		my $sth = $LSC{MySQL}->prepare("SELECT Sum(PrivatePoints),  Sum(LeaguePoints),  Sum(LeagueWon),  Sum(LeagueLost) from lsc_leagues_strafpunkte where League=? and TeamUser=1 and TeamUserID=? and (EndDate > now() or EndDate=0)");

		if ($sth->execute($_[1], $_[0])) {
			my $punish = $sth->fetchrow_arrayref();
			$sth->finish;
			unless ($punish) {
				return {PrivatePoints=>0,  LeaguePoints=>0,  LeagueWon=>0,  LeagueLost=>0};
			}
			return {PrivatePoints=>$punish->[0],  LeaguePoints=>$punish->[1],  LeagueWon=>$punish->[2],  LeagueLost=>$punish->[3]};
		}	
		return {PrivatePoints=>0,  LeaguePoints=>0,  LeagueWon=>0,  LeagueLost=>0};
}
sub StrafpunkteTeamZeigen {
	if (!$LSC{Strafpunkte}) {
		print $LSC{TEXT}{ERROR}[9].br;
		return;
	}
	my $Team = shift || return;

	my $sth = $LSC{MySQL}->prepare("SELECT id,  League,  TeamUser,  TeamUserID, GameID,  ShortInfo,  FullInfo,  DATE_FORMAT(InsertDate,'%e.%m.%Y'),  DATE_FORMAT(EndDate,'%e.%m.%Y'),  PrivatePoints,  LeaguePoints,  LeagueWon,  LeagueLost,  AdminID from lsc_leagues_strafpunkte where TeamUser=1 and TeamUserID=? order by League, InsertDate desc");
	unless ($sth->execute($Team)) {
		print $LSC{TEXT}{Strafpunkte}[1].br;
		return;
	}
	my $Template = TemplateLoad1($LSC{Templates}{'StrafpunkteTeam'});
	unless ($Template) {
		print "Konnte Template nicht laden! ($!)".br;
		return;
	}

	if ($LSC{Admin}) {
		print "<B>Admin:</B> ".ShowLink({Name=>"new punish for current league", Script=>"$LSC{user_pl}", Action=>"Punish", Action2=>"new", Special=>$Team, League=>$LSC{League}}).br.br;
	}
	if ($sth->rows) {
		print TemplateMaker($Template->{'Headline'}, {});
	}
	my $LastLeague = 0;
	while (my $ref = $sth->fetchrow_arrayref()) {
		if ($ref->[1] ne $LastLeague) {
			print TemplateMaker($Template->{'LeagueHeadline'}, {"LSC-LigaName"=>ShowLink({Name=>LigaName($ref->[1]), Script=>$LSC{show_pl}, Action=>"", Action2=>"", Special=>0, League=>$ref->[1]})});
			$LastLeague = $ref->[1];
		}
		my $values = {};
		$values->{"LSC-ID"} = $ref->[0];
		if ($ref->[2] == 2) {
			#Team
			my ($Name, undef) = UserNameUndStatusVonID($ref->[3]);
			$values->{"LSC-Name"} = UserLink($Name, $ref->[3]);
		} elsif ($ref->[2] == 1) {
			#Team
			my ($Name, undef) = TeamnameAndUserFromTeamID($ref->[3]);
			$values->{"LSC-Name"} = TeamLink({Name=>$Name, ID=>$ref->[3], HideVote=>1, League=>$ref->[1]});
		} else {
			$values->{"LSC-Name"} = "unknown";
		}

		$values->{"LSC-Date"} = $ref->[7];
		$values->{"LSC-EndDate"} = $ref->[8];
		if ($ref->[8] eq '0.00.0000') {
			$values->{"LSC-EndDate"} = $LSC{TEXT}{Strafpunkte}[6];
		}

		$values->{"LSC-ShortInfo"} = $ref->[5];
		$values->{"LSC-FullInfo"} = "";
		$values->{"LSC-FullInfo"} = "<b>Admin-Info: </b>".$ref->[6] if $LSC{Admin};

		#punish
		$values->{"LSC-Punish"} = "";
		if ($ref->[9]) {
			#Liga-Strafpunkte
			$values->{"LSC-Punish"} = $ref->[9]." ".$LSC{TEXT}{Strafpunkte}[2];
		} 
		if ($ref->[10]) {
			#Ligapunkte
			$values->{"LSC-Punish"} .= '<br>' if $values->{"LSC-Punish"};
			$values->{"LSC-Punish"} .= $ref->[10]." ".$LSC{TEXT}{Strafpunkte}[3];
		} 
		if ($ref->[11]) {
			#Sieg
			$values->{"LSC-Punish"} .= '<br>' if $values->{"LSC-Punish"};
			$values->{"LSC-Punish"} .= $ref->[11]." ".$LSC{TEXT}{Strafpunkte}[4];
		} 
		if ($ref->[12]) {
			#Niederlage
			$values->{"LSC-Punish"} .= '<br>' if $values->{"LSC-Punish"};
			$values->{"LSC-Punish"} .= $ref->[12]." ".$LSC{TEXT}{Strafpunkte}[5];
		} 
		
		if ($ref->[4]) {
			$values->{"LSC-Punish"} = RecapLink($ref->[1], $ref->[4], $values->{"LSC-Punish"});
		}
		$values->{"LSC-Punish"} = "?" unless $values->{"LSC-Punish"};


		my ($AdminName, undef) = UserNameUndStatusVonID($ref->[13]);
		$values->{"LSC-AdminLink"} = "".UserLink($AdminName, $ref->[13]);

		if ($LSC{Admin}) {
			$values->{"LSC-Admin"} = ShowLink({Name=>"edit/delete", Script=>"$LSC{user_pl}", Action=>"Punish", Action2=>"edit", Special=>$ref->[0], League=>$ref->[1]});
		} else {
			$values->{"LSC-Admin"} = "";
		}
		print TemplateMaker($Template->{'Strafpunkte'}, $values);
	}
	if ($sth->rows) {
		print TemplateMaker($Template->{'Bottom'}, {});
	} else {
		print TemplateMaker($Template->{'empty'}, {});
	}

	$sth->finish;


}

1