
###############################################################################
# Sources From LigaScript                                                     #
###############################################################################
# LigaScript: Online Ligaverwaltung                                           #
#                                                                             #
# Version:        LigaScript Full Version 2.0.1 BETA!                         #
# First-Released: August 1999                                                 #
# Distributed by: http://leagues.ihoax.de                                     #
# =========================================================================== #
# Copyright (c) 2000-2003 Joerg Nass (www.ihoax.de) - All Rights Reserved.    #
# Software by: Joerg Nass                                                     #
# Kontaktinformationen und weiteres sind jeweils auf den angebenen            #
# Homepages zu finden!                                                        #
###############################################################################
#  ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!!                #
#  Bitte den Disclaimer und die Nutzungsbedingungen in der Datei              #
#  LSCConfig.pm lesen!                                                        #
#                                                                             #
###############################################################################





# Tabellenfunktion 2
# Tabellen werden aus den vorbereiteten Daten von LSCPoints erstellt
# Variable TableCreat:
# 0 = undef
# 1 = Tabellen aus LSCPoints erstellen und sortieren
# 2 = Tabelle aus gespeicherter Platzierung erstellen
# 3 = Tabelle aus gespeicherter Platzierung erstellen, Platzierungen werden
#		ber ein externes Script alle X Minuten aktualisiert

sub Tabelle2DBFehler {
	print "Es ist ein Fehler beim Laden/Erstellen der Tabelle aufgetreten, bitte wende dich an einen Admin.".br;
	print "<!-- $_[0] -->";
	print $_[0].br;

}
sub Tabelle2SortierungLaden {
	my $League = shift || return;

	if ($LSC{TabelleDefinitionSortierung}) {
		return @{$LSC{TabelleDefinitionSortierung}};
	}

	my $update = shift || 0;
	if (!$update) {
		if ($LSC{LeagueData}) {
			if ($LSC{LeagueData}->{TableCreat} &&
					($LSC{LeagueData}->{TableCreat} == 2 ||
					$LSC{LeagueData}->{TableCreat} == 3)) {
				return {K=>"Rank", S=>1};
			}
		} else {
			return;
		}
	}

	$League = $LSC{MySQL}->quote($League);

	my $sth;
	$sth = $LSC{MySQL}->prepare("
			SELECT  Name,  W as Won,  L as Lost,  D as Draw, LP,  PD, Games
			FROM lsc_leagues_tabelle_order 
			WHERE League=$League");

	$sth->execute or return Tabelle2DBFehler($sth->errstr);
    
	my $t = $sth->fetchrow_hashref() || return; 
	$sth->finish();

	local *b = sub {
		if ($_[0] < 0) {
			return -$_[0];
		}
		return $_[0];
	};

	my @order = sort {b($t->{$a}) <=> b($t->{$b})} keys %{$t};
	foreach (@order) {
		$_ = {K=>$_, S=>$t->{$_}};
	}
	return @order;
}
sub Tabelle2SpaltenLaden {
	my $League = shift || return undef;

	if ($LSC{TabelleDefinitionSpalten}) {
		return @{$LSC{TabelleDefinitionSpalten}};
	}
	
	my $short = shift || 0;

	if ($short) {
		my $position = {POS=>1, Teamname=>2};
		my $name = {POS=>"", Teamname=>""};
		return ({K=>POS, S=>1, Name=>"#"}, {K=>TeamName, S=>2, Name=>"Team"});
	}
	$League = $LSC{MySQL}->quote($League);

	my $sth;
	$sth = $LSC{MySQL}->prepare("
			SELECT  * 
			FROM lsc_leagues_tabelle 
			WHERE League=$League");

	$sth->execute or return Tabelle2DBFehler($sth->errstr);
    
	my $position = $sth->fetchrow_hashref() || return; 
	$sth->finish();

	$sth = $LSC{MySQL}->prepare("
			SELECT  * 
			FROM lsc_leagues_tabelle_namen 
			WHERE League=$League");

	$sth->execute or return Tabelle2DBFehler($sth->errstr);
    
	my $namen = $sth->fetchrow_hashref() || return; 
	$sth->finish();

	my @order = ();
	foreach (sort {$position->{$a} <=> $position->{$b}} keys %{$position}) {
		push @order, {K=>$_, S=>$position->{$_}, Name=>$namen->{$_}} if ($position->{$_} > 0 && $_ ne "League");
	}
	return @order;
}
sub Tabelle2LayoutLaden {
	my $League = shift || "";
	my $short = shift || 0;

	unless ($League) {
		return;
	}
	if ($short) {
		return ();
	}
	$League = $LSC{MySQL}->quote($League);

	my $sth;
	$sth = $LSC{MySQL}->prepare("
			SELECT  Rank, Color 
			FROM lsc_leagues_tabelle_farben 
			WHERE League=$League");

	$sth->execute or return Tabelle2DBFehler($sth->errstr);

	my %farben = ();
	while (my $ref = $sth->fetchrow_arrayref()) {
		$farben{$ref->[0]} = $ref->[1];
	}
	$sth->finish();

	return %farben;

}

sub Tabelle2Feldausgeben {
	my $D = shift || return "<td></td>";
	
	#Lokale Funktionen zum Darstellen der Spalten:
	my $Layout = $TableLayout[$D->{Layout} || 0].($D->{Style});
	#print $D->{Style};
	my $TD1	= "<TD $Layout width=165>";
	my $TD	= "<TD $Layout align=center>";

	#print $TD;

	if ($D->{Feld} eq "TeamName") {
		print $TD1.TeamLink($D->{Daten}{Name}, $D->{Daten}{Team}, "Tabelle", 1);
	}
	elsif ($D->{Feld} eq "TeamNamePos") {
		print $TD1.TeamLink($D->{Daten}{Name}, $D->{Daten}{Team}, "Tabelle", 1)."(".$D->{Daten}{Rank2}.")";
	}
	elsif ($D->{Feld} eq "Won") {
		print $TD.$D->{Daten}{Won};
	}
	elsif ($D->{Feld} eq "Lost") {
		print $TD.$D->{Daten}{Lost};
	}
	elsif ($D->{Feld} eq "Draw") {
		print $TD.$D->{Daten}{Draw};
	}
	elsif ($D->{Feld} eq "Total") {
		print $TD.$D->{Daten}{Games};
	}
	elsif ($D->{Feld} eq "LP") {
		print $TD.$D->{Daten}{LP};
	}
	elsif ($D->{Feld} eq "PCT") {
		print $TD.($D->{Daten}{Won} ? Round(1000/$D->{Daten}{Games}*$D->{Daten}{Won})/1000 : 0);
	}
	elsif ($D->{Feld} eq "Rank") {
		print $TD.RankingRangName($D->{Daten}{LP});
	}
	elsif ($D->{Feld} eq "POS") {
		print $TD.$D->{Platz}.".";
	}
	elsif ($D->{Feld} eq "TotalPoints") {
		print $TD.$D->{Daten}{PPoints}.":".$D->{Daten}{MPoints};
	}
	elsif ($D->{Feld} eq "PDifference") {
		print $TD.($D->{Daten}{PPoints}-$D->{Daten}{MPoints});
	}
	elsif ($D->{Feld} eq "GB") {
		my $gb = 0;
		if ($D->{SiegeVomErsten} > $D->{Daten}{Won}) {
			$gb += $D->{SiegeVomErsten} - $D->{Daten}{Won}
		}
		if ($D->{SpieleVomErsten} > ($D->{Daten}{Won} + $D->{Daten}{Lost})) {
			$gb += ($D->{SpieleVomErsten} - ($D->{Daten}{Won} + $D->{Daten}{Lost})) * 0.5;
		}


		print $TD.$gb;
	}
	elsif ($D->{Feld} eq "Home") {
		if ($D->{Daten}{HomeWon} || $D->{Daten}{HomeDraw} || $D->{Daten}{HomeLost}) {
			print $TD.$D->{Daten}{HomeWon}.":".
				($D->{Daten}{HomeDraw}? $D->{Daten}{HomeDraw}.":" :"").
				$D->{Daten}{HomeLost}
		} else {
			print $TD."-";
		}
	}
	elsif ($D->{Feld} eq "Road") {
		if (($D->{Daten}{Won} - $D->{Daten}{HomeWon}) 
				|| 
			($D->{Daten}{Draw} - $D->{Daten}{HomeDraw})
			||
			($D->{Daten}{Lost} -$D->{Daten}{HomeLost})) {
			print $TD."".($D->{Daten}{Won} - $D->{Daten}{HomeWon}).":".
				(($D->{Daten}{Draw} - $D->{Daten}{HomeDraw} > 0)? ($D->{Daten}{Draw} - $D->{Daten}{HomeDraw}).":" :"").
				($D->{Daten}{Lost} -$D->{Daten}{HomeLost});
		} else {
			print $TD."-";
		}
	}
	elsif ($D->{Feld} eq "L10") {
		if ($D->{Daten}{Last10Won} || $D->{Daten}{Last10Draw} || $D->{Daten}{Last10Lost}) {
			print $TD.$D->{Daten}{Last10Won}.":".
				($D->{Daten}{Last10Draw}? $D->{Daten}{Last10Draw}.":" :"").
				$D->{Daten}{Last10Lost}	
		} else {
			print $TD."-";
		}
	}
	elsif ($D->{Feld} eq "Streak") {
		my @t = ('-', $LSC{TEXT}{Tabelle}[0],$LSC{TEXT}{Tabelle}[1],$LSC{TEXT}{Tabelle}[2]);
		print $TD.$t[$D->{Daten}{CurrentStreak}]." ".($D->{Daten}{CurrentStreakC} || "");
	}
	elsif ($D->{Feld} eq "Main_Group_Result") {
		print $TD.$D->{Daten}{MainGroupWon}.":".$D->{Daten}{MainGroupLost};
	} 
	elsif ($D->{Feld} eq "Sub_Group_Result") {
		print $TD.$D->{Daten}{SubGroupWon}.":".$D->{Daten}{SubGroupLost};
	}
	elsif ($D->{Feld} eq "Special") {
		print $TD."?";
	}
	elsif ($D->{Feld} eq "TeamRate") {
		print $TD;
		print $LSC{Vote}{S} ? Vote_TeamIndikator($D->{Daten}{Team}) : "-";
	}
	


	print "</td>";
}
# Tabellenfunktionen:
sub Tabelle2Simpel {
	my $League = $_[0] || 0;
	my $update = $_[2] || 0;
	my $short = $_[3] || 0;

	unless ($League) {
		print "Keine Liga gewhlt.";
		return;
	
	}

	my $WhereRank = "";
	if (!$update && $LSC{LeagueData}) {
		if ($LSC{LeagueData}->{TableCreat} &&
				($LSC{LeagueData}->{TableCreat} == 2 ||
				$LSC{LeagueData}->{TableCreat} == 3)) {
			$WhereRank = "and Rank!=0";
		}
	}

	my @TabellenSortierung = Tabelle2SortierungLaden($League, $update);
	unless (scalar(@TabellenSortierung)) {
		print "Fr die Tabelle wurden keine Sortierungsregeln festgelegt." if !$update;
		return;
	}
	my $OrderSelect = "";
	my $Order = "";

	foreach	my $o (@TabellenSortierung) {
		if ($o->{S} !=0) {
				$Order .= ", " if ($Order);
			if ($o->{K} eq 'PD') {
				$OrderSelect .= ", ";
				$OrderSelect .= "PPoints -MPoints as PD";

				$Order .= "PD ";
			} else {
				$Order .= "$o->{K} ";
			}
			$Order .= " desc" if ($o->{S} < 0);
			$Order .= " asc" if ($o->{S} > 0);

		}
	}
	my @TabellenSpalten = Tabelle2SpaltenLaden($League, $short);
	unless (scalar(@TabellenSpalten)) {
		print "Fr die Tabelle wurden noch nicht alle Daten festgelegt." if !$update;
		return;
	}

	my $Menue = "";
	my $Start = $_[1] || "0";
	$Start = 0 if ($Menue =~/[^0-9]/);
	if (!$update && !$short) {
		my $AnzahlUser = Liga_AnzahlteilnehmenderUser($League);
		if ($AnzahlUser > $LSC{anzahlteamsintabelle}) {
			my $i = 0;
			for (my $s = 0; $s < $AnzahlUser; $s+=$LSC{anzahlteamsintabelle}) {
				if ($s == $Start) {
					$Menue .= "\[=&gt ".$i." &lt=\]";
				} else {	
					$Menue .= "<a class=standard href=$scriptname?".
					"League=$LSC{League}&Action=Standings&Action2=$s>\[".
					$i."\]</a>";
				}
				$i++;
			}
		}
		print $Menue.br.br if $Menue;
	}
	my $sth;
	my $limit = "Limit $Start, $LSC{anzahlteamsintabelle}";
	if ($update) {
		$Start = 0;
		$limit = "";
	}
	if ($LSC{TabelleDefinitionMainGroup}) {
		$WhereRank .= " and Main_Group=$LSC{TabelleDefinitionMainGroup}";

	} elsif ($LSC{TabelleDefinitionSubGroup}) {
		$WhereRank .= " and Sub_Group=$LSC{TabelleDefinitionSubGroup}";
	}
	my $do = "
			SELECT * $OrderSelect
			FROM lsc_teams_league L, lsc_teams T 
			WHERE L.League=".$LSC{MySQL}->quote($League)." and L.Team=T.ID ".$WhereRank." order by $Order
			$limit";
	$sth = $LSC{MySQL}->prepare($do);
	$sth->execute or (print "Folgender Fehler ist aufgetrehten: ".$sth->errstr.br);
	if (!$update) {
		print '<TABLE width= 100% BORDER="0" CELLSPACING="0" CELLPADDING="2">';
	}

	my $TD	= "<td class=$TableHeaderClass align=center>";
	my $TD1	= "<td class=$TableHeaderClass align=left>";
	my $_TD = "</td>";

	if (!$update) {
	 	print "<tr>\n";
		foreach  (@TabellenSpalten) {
					if ($_->{K} =~ /Name/) {
						print $TD1.$_->{Name}.$_TD;
					} else {
						print $TD.$_->{Name}.$_TD;
					}
		}
		print "</tr>\n";
	}

	#Layout:
	my %Farben = $update ? () : Tabelle2LayoutLaden($LSC{League}, $short);


	my $PosCounter = $Start;
	my $SpieleVomErsten = 0;
	my $SiegeVomErsten = 0;
	if ($update) {
		#update Modus... Tabelle wird erstellt und Platzierungen gespeichert
		Require("LSCPoints.pm");
		
		my $rank=1;
		if ($LSC{TabelleDefinitionMainGroup}) {
			$rank = 2;
		} elsif ($LSC{TabelleDefinitionSubGroup}) {
			$rank = 3;
		}
		
		my $Group = 0;
		my %Groups = ();
		my $RealCounter = 0;
		while (my $ref = $sth->fetchrow_hashref()) {
			$RealCounter++;
			$PosCounter = $RealCounter;

			# NBA Conference Regel:
			if ($LSC{TabelleDefinitionNBAConferenceRules}
					&&$LSC{TabelleDefinitionMainGroup}) {
					if ($RealCounter == 1) {
						$Group = $ref->{Sub_Group};
					
					} elsif ($Group > 1) {
						if ($Group != $ref->{Sub_Group}) {
							$PosCounter = 2;
							$Group = -1;
						} else {
							$PosCounter += 1;
						}

					}
			} elsif ($LSC{TabelleDefinitionNBAConferenceRules2}
					&&$LSC{TabelleDefinitionMainGroup}) {
#						print "drin: $ref->{Sub_Group}".br;
					if ($RealCounter == 1) {
						$Groups{$ref->{Sub_Group}} = 1;
						$Group = 1;
#						print " - erster: 	$ref->{Sub_Group}".br;				
					} elsif ($Group < 3) {
#						print " - noch nicht 3".br;				
						if (!$Groups{$ref->{Sub_Group}}) {
							$Groups{$ref->{Sub_Group}} = 1;
							$PosCounter = $Group+1;
							$Group++;
#						print " - - noch nicht drin: 	$ref->{Sub_Group}".br;				

						} else {
#						print " - - schon drin: 	$ref->{Sub_Group}".br;				
							$PosCounter += 1;
						}
					}
#						print " => position: $PosCounter".br;
			}
			# /NBA Conference Regel

			Tabelle2PlatzierungUpdaten($ref->{Team}, $League, {$rank=>$PosCounter});
		}
	} else {
		while (my $ref = $sth->fetchrow_hashref()) {
			my $Layout = $PosCounter++ % 2;
			$SpieleVomErsten = $ref->{Games} if ($PosCounter==1);
			$SiegeVomErsten = $ref->{Won} if ($PosCounter==1);
			print "<tr>";
			foreach (@TabellenSpalten) {
				Tabelle2Feldausgeben({Feld=>$_->{K}, Daten=>$ref, Layout=>$Layout, Platz=>$PosCounter,
										SpieleVomErsten=>$SpieleVomErsten, SiegeVomErsten=>$SiegeVomErsten, Style=>($Farben{$PosCounter} || "")});
			}
			print "</tr>";

		}
	}
	$sth->finish();
	print "</table>" if !$update;
	print br.$Menue if (!$update && !$short);
}
1