
###############################################################################
# Sources From LigaScript                                                     #
###############################################################################
# LigaScript: Online Ligaverwaltung                                           #
#                                                                             #
# Version:        LigaScript Full Version 2.1.0	                              #
# First-Released: August 1999                                                 #
# Distributed by: http://www.scroax.net                                       #
# =========================================================================== #
# Copyright (c) 2004 Joerg Nass (www.scroax.net) - All Rights Reserved.	      #
# Software by: Joerg Nass                                                     #
# Kontaktinformationen und weiteres sind jeweils auf den angebenen            #
# Homepages zu finden!                                                        #
###############################################################################
#  ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!!                #
#  Bitte den Disclaimer und die Nutzungsbedingungen in der Datei              #
#  LSCConfig.pm lesen!                                                        #
#                                                                             #
###############################################################################




our @S_Plan;
Require("LSCspielplan.dat.pm");
sub SpielplanAktuellerSpieltag {
	my $League = shift;
	my ($select,$from,$where,$group,$order);
		$select	= "Spieltag";
		$from	= "lsc_leagues_spieltag";
		$where = "League=$LSC{League}";
		$group	= "";
		$order	= "";
		my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $order");
		$sth->execute();
		my $r = $sth->fetchrow_arrayref();
		$sth->finish;	
#print "$r->[0]. Spieltag".br;
		
	return $r->[0] || 0;
}
sub SpielplanSpieltagGegner {
	my $CT = shift;
	my $AktuellerSpieltag = shift;
	my $AnzahlTeams = shift || 	SpielplanTeamAnzahlLaden();

#print "team $CT / ST: $AktuellerSpieltag / Teams:$AnzahlTeams".br;
#print "SG: $CT, $AktuellerSpieltag Teams: $AnzahlTeams".br;
	my $SP = ($AnzahlTeams + ($AnzahlTeams%2));

	my $gegner = 0;
	local *betrag = sub {
		if ($_[0] && $_[0] < 0) {
			return -$_[0];
		}
		return $_[0];
	};
		
	if ($LSC{LeagueData}{AnzahlSpiele} == 2 &&
			$AktuellerSpieltag >= $SP) {
		$AktuellerSpieltag = $AktuellerSpieltag - $SP +1;
#		print "Spieltag Rckrunde: $AktuellerSpieltag".br;
		while(betrag($S_Plan[$SP][$CT][$gegner] || 0) != $AktuellerSpieltag
			&& $gegner < $SP) {
			$gegner++;
		}
		if ($gegner >= $SP) {
#			print "Fehler beim erstellen des Spielplans (Rckrunde)!".br;
			return;
		}
		return ($gegner, $S_Plan[$SP][$CT][$gegner] < 0);
	} else {
		while(betrag($S_Plan[$SP][$CT][$gegner] || 0) != $AktuellerSpieltag
			&& $gegner < $SP) {
			$gegner++;
		}
		
		if ($gegner >= $SP) {
#			print "Fehler beim erstellen des Spielplans!".br;
			return;
		}
		return ($gegner, $S_Plan[$SP][$CT][$gegner] > 0);
	}
}
sub SpielplanSpieltagSpieltWo {
	my $Team = shift;
	my $Gegner = shift;

	# Es wurde noch kein Spiel gespielt:
	my $AnzahlTeams = shift || 	SpielplanTeamAnzahlLaden();

	my $SP = ($AnzahlTeams + ($AnzahlTeams%2));

	my $Spieltag = $S_Plan[$SP][$Team][$Gegner];
	if ($Spieltag) {
		return (1, $Spieltag>0?1:0);
	}
	print "Es konnte kein Spielzeitpunkt gegen diesen Gegner aus dem Spielplan ermittelt werden.".br;
	return (0,0)
}
sub SpielplanTeamSortierungLaden {
		$sth = $LSC{MySQL}->prepare("
			SELECT  TOrder 
			FROM lsc_leagues_spielplan
			WHERE League=$LSC{League}");	

		my @Teams = ();
		if ($sth->execute) {
			my $ref = $sth->fetchrow_arrayref();
			@Teams = split(/\|/, $ref->[0]) if $ref->[0];
		} else {
			print "Spielplan konnte nicht geladen werden!".br;
		}
		$sth->finish();
		return @Teams;
}
sub SpielplanTeamAnzahlLaden {
		$sth = $LSC{MySQL}->prepare("
			SELECT  TCount 
			FROM lsc_leagues_spielplan
			WHERE League=$LSC{League}");	

		if ($sth->execute) {
			my $ref = $sth->fetchrow_arrayref();
			$sth->finish();
			return $ref->[0];
		} else {
			print "Spielplan konnte nicht geladen werden!".br;
		}
		return 0;
}
sub SpielplanAnzeigenTeam {
	my $Team = shift;
	unless ($Team) {
		print "Kein Spielplan verfgbar.".br;
		return;
	}
#	old:
#	my $AnzahlTeams = Liga_AnzahlteilnehmenderUser($LSC{League});
#   new:
	my $AnzahlTeams = SpielplanTeamAnzahlLaden();
	unless ($AnzahlTeams) {
		print "Die Liga enthlt noch keine Teams";
	}
	my $Spieltage = ($AnzahlTeams + ($AnzahlTeams%2))-1;
	my $RueckSpiel = 0;
	if ($LSC{LeagueData}{AnzahlSpiele} == 2) {
			#auch Rckspiel! also Doppelt so viele Spieltage
			$RueckSpiel = $Spieltage;
			$Spieltage+=$Spieltage;
	}

	my %Members = Members();
#	old:
#	my @Members = (0,sort {$a<=>$b} keys %Members);
#   new:
	my @Members = (0, SpielplanTeamSortierungLaden());


	my $teamnummer = 0;
	while (defined($Members[$teamnummer]) && $Members[$teamnummer] ne $Team) {
		$teamnummer++;
	}
	$teamnummer--;
	unless (defined($Members[$teamnummer])) {
		print "Spielplan konnte nicht erstellt werde. Bitte wende dich an einen Admin!";
		return;
	}
	
	print '<TABLE width="100%" BORDER="0" CELLSPACING="1" CELLPADDING="2" align=center>';
		my $TD1	= "<TD class=Headline algin=left>";
		my $td	= "<TD align=center class=Headline>";
		my $td_ = "</td>";

	print "<tr>$TD1 Spieltag$td_$td&nbsp;$td_$td&nbsp;$td_</tr>";

	#nlc, rckrunde ausblenden

	my $sthgroup = $LSC{MySQL}->prepare("SELECT Main_Group  FROM lsc_teams_league WHERE Team=$Team and League=$LSC{League}");
	$sthgroup->execute();
	my $ref = $sthgroup->fetchrow_arrayref();
	my $group = $ref->[0] || 0;
	$sthgroup->finish;

	my $counter=0;
	for (my $Spiel = 1; $Spiel<=$Spieltage ; $Spiel++) {
		if ($RueckSpiel+1 == $Spiel) {
			print "<tr><td></td><td><br></td></td></tr>";
#			print "<tr><td></td><td>$LSC{TEXT}{Ergebnisse}[7]</td></td></tr>";
		}	
		my $CT = $teamnummer;
		
		my ($gegner, $heimspiel) = SpielplanSpieltagGegner($CT, $Spiel, $AnzahlTeams);

		unless ($heimspiel) {
			my $t = $CT;
			$CT = $gegner;
			$gegner = $t;
		}
		my $Team1 = $Members[$CT+1];
		my $Team2 = $Members[$gegner+1];
		$Members{$Team1}=~s/ /&nbsp;/gg if $Members{$Team1};
		$Members{$Team2}=~s/ /&nbsp;/gg if $Members{$Team2};

		# nlc, rckrunde ausblenden...
		if ($RueckSpiel < $Spiel &&$LSC{LeagueData}{Function} && $LSC{LeagueData}{Function} == 5) {
			my $gteam = 0;
			if ($Team == $Team1) {
				$gteam = $Team2;
			} elsif ($Team == $Team2) {
				$gteam = $Team1;
			}
	
			my $sthgroup = $LSC{MySQL}->prepare("SELECT Main_Group  FROM lsc_teams_league WHERE Team=$gteam and League=$LSC{League}");
			$sthgroup->execute();
			my $ref = $sthgroup->fetchrow_arrayref();
			$sthgroup->finish;

			if ($ref->[0] && $ref->[0] ne $group) {
				next;
			}

		}

		my $T1out = $Team1 ? TeamLink($Members{$Team1}, $Team1, 'Tabelle', !$LSC{Vote}{S}{Spielplan}) : 'spielfrei';
		my $T2out = $Team2 ? TeamLink($Members{$Team2}, $Team2, 'Tabelle', !$LSC{Vote}{S}{Spielplan}) : 'spielfrei';
		
		my $layout = $counter++ % 2;
		$TD1	= "<TD $TableLayout[$layout] algin=left width=80>";
		$td	= "<TD align=center $TableLayout[$layout]>";
		$td_ = "</td>";
		
		my $recap;
		my $Gameid='';
		if ($Team1 && $Team2 && (my $Game = SpielplanErgebnisFuerAB($Team1, $Team2))) {
			
			
			my($m,$d,$y) = (1,1,1);
			($m,undef,$d,$y,undef) = ($Game->[3] =~ /(\w{3})(\w*) (\d+) (\w{3})(\w+)/);

			my $RecapLink = RecapLink($LSC{League}, $Game->[0], "$Game->[1]:$Game->[2]");
			
			$recap = "$RecapLink";
			$Gameid=" ($Game->[0])";
		} else {
			$recap = "-";
		}
		if ($LSC{LeagueData}{Function} && $LSC{LeagueData}{Function} == 5) {
			$td	= "<TD align=left $TableLayout[$layout]>";
			if ($Team == $Team1) {
				print "<tr>$TD1$Spiel.&nbsp;$Gameid$td_$td$T2out$td_$td$recap$td_</tr>";
			} elsif ($Team == $Team2) {
				print "<tr>$TD1$Spiel.&nbsp;$Gameid$td_$td \@$T1out$td_$td$recap$td_</tr>";
			} else {
				print "<tr>$TD1$Spiel.&nbsp;$Gameid$td_$td$T1out vs. $T2out$td_$td$recap$td_</tr>";
			}
		} else {
			print "<tr>$TD1$Spiel.&nbsp;$Gameid$td_$td$T1out vs. $T2out$td_$td$recap$td_</tr>";
		}

#		print RecapLink($LSC{League}, $ref->[0], "$ref->[6]:$ref->[5]");
	}
	print "</table>";

}
sub SpielplanAnzeigen {
#	old:
#	my $AnzahlTeams = Liga_AnzahlteilnehmenderUser($LSC{League});
#   new:
	my $AnzahlTeams = SpielplanTeamAnzahlLaden();
	unless ($AnzahlTeams) {
		print "Spielplan wurde noch nicht initialisiert.".br;
		return;
	}
	my $AktuellerSpieltag = shift || $LSC{Spieltag} || 1;
	
	my $SP = ($AnzahlTeams + ($AnzahlTeams % 2));
	my $Spiele = $SP/2;
	
	my %Members = Members();
#	old:
#	my @Members = (0,sort {$a<=>$b} keys %Members);
#   new:
	my @Members = (0, SpielplanTeamSortierungLaden());
	
	my %Teams;
	for (my $i=0;$i<$SP;$i++) {
		$Teams{$i}=1;
	}
	print '<TABLE BORDER="0" width=100% CELLSPACING="1" CELLPADDING="2" align=center>';
		my $TD1	= "<TD class=Headline algin=left>";
		my $td	= "<TD align=center class=Headline>";
		my $td_ = "</td>";

		print "<tr>$TD1#$td_$td$AktuellerSpieltag. Spieltag$td_$td&nbsp;$td_$td&nbsp;$td_</tr>";
	for (my $Spiel = 1; $Spiel<=$Spiele ; $Spiel++) {
		my ($CT) = sort {$a<=>$b} keys %Teams;
		my ($gegner, $heimspiel) = SpielplanSpieltagGegner($CT, $AktuellerSpieltag, $AnzahlTeams);
		unless ($heimspiel) {
			my $t = $CT;
			$CT = $gegner;
			$gegner = $t;
		}
		delete $Teams{$CT};
		delete $Teams{$gegner};
	
		#ausgabe:
		my $Team1 = $Members[$CT+1];
		my $Team2 = $Members[$gegner+1];
		#$Members{$Team1}=~s/ /&nbsp;/gg if $Members{$Team1};
		#$Members{$Team2}=~s/ /&nbsp;/gg if $Members{$Team2};
		
		my $T1out = $Team1 ? TeamLink($Members{$Team1}, $Team1, 'Tabelle', !$LSC{Vote}{S}{Spielplan}) : 'spielfrei';
		my $T2out = $Team2 ? TeamLink($Members{$Team2}, $Team2, 'Tabelle', !$LSC{Vote}{S}{Spielplan}) : 'spielfrei';
		
		my $layout = $Spiel % 2;
		$TD1	= "<TD $TableLayout[$layout] algin=left>";
		$td	= "<TD align=center $TableLayout[$layout]>";
		$td_ = "</td>";
		
		my $recap;
		my $Gameid='';
		if ($Team1 && $Team2 && (my $Game = SpielplanErgebnisFuerAB($Team1, $Team2))) {
			
			
			my($m,$d,$y) = (1,1,1);
			($m,undef,$d,$y,undef) = ($Game->[3] =~ /(\w{3})(\w*) (\d+) (\w{3})(\w+)/);

			my $RecapLink = RecapLink($LSC{League}, $Game->[0], "$Game->[1]:$Game->[2]");
			
			$recap = "$RecapLink";
			$Gameid=" ($Game->[0])";
		} else {
			$recap = "-";
		}
		
		my $spielid = "$LSC{League}-$AktuellerSpieltag-$Spiel";
		print "<tr>$TD1$spielid $Gameid$td_$td$T1out$td_$td$T2out$td_$td$recap$td_</tr>";
		
#		print RecapLink($LSC{League}, $ref->[0], "$ref->[6]:$ref->[5]");
	}
	print "</table>";
	my $ssb = SpielplanSpieltagBeschreibung($AktuellerSpieltag);
	if ($ssb) {
		print '<div align=center><B><I>'.$ssb.'</I></B></div>';
	}
	my $ueT = join(', ', sort {$a<=>$b} keys %Teams);
	if ($ueT) {
		print "brige Teams: $ueT".br;
	}


}

sub SpielplanErgebnisFuerAB {
	my $Team1 = shift;
	my $Team2 = shift;
	unless ($Team1 && $Team2) {
		return;
	}
	my ($select,$from,$where,$group,$order);
		$select	= "G1.Game, G1.Points, G2.Points,
			DATE_FORMAT(D.Date,'%M %e %W'), 
			G1.Won, G1.Lost, G1.Draw";
		$from	= "$Select{Game}{From}";
		$from .= " ".$Select{Game}{JoinG2};
		$where = $Select{Game}{WhereHome}." and G1.Team=$Team1 and G2.Team=$Team2";
				$where =~s/\#LEAGUE/$LSC{League}/gg;		
		$group	= "";
		$order	= "";
		my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $order");
		$sth->execute();
		my $Spiel = $sth->fetchrow_arrayref();
		$sth->finish;
	return $Spiel;
}
sub SpielplanNeuesErgebnisMoeglich {
	my $AktuellerSpieltag = $LSC{Spieltag} || 0;
	if ($LSC{Spieltag} < 1) {
		return;
	}
	my $AnzahlTeams = SpielplanTeamAnzahlLaden();
	
	my $FirstTeamID = shift || $LSC{userteamid};
	my %Members = Members();
#	old:
#	my @Members = (sort {$a<=>$b} keys %Members);
#   new:
	my @Members = SpielplanTeamSortierungLaden();

	
	my $team=0;
	while($Members[$team] ne $FirstTeamID  && $team < $AnzahlTeams) {
		$team++;
	}

	if ($team >= $AnzahlTeams) { 
		print "Es konnte kein Gegner fr diesen Spieltag ermittelt werden! (nem1)";
		return;
	}
	
	my ($gegner, $heimspiel) = SpielplanSpieltagGegner($team, $AktuellerSpieltag, $AnzahlTeams);
	unless (defined($gegner)) {
		print "Es konnte kein Gegner fr diesen Spieltag ermittelt werden! (nem2)";
		return;
	}
	$team = $FirstTeamID ;
	my $gegner_ = $Members[$gegner];
#print "gegnernummer: $gegner, $heimspiel / $gegner_".br;
	
	unless ($heimspiel) {
		my $t = $team;
		$team = $gegner_;
		$gegner_ = $t;
	}
	my $Spiel = SpielplanErgebnisFuerAB($team, $gegner_);
	#unless ($Spiel) {
	#	print "Fr diesen Spieltag kann kein Spiel eingetragen werden!".br;
	#	return;
	#}
	if ($Spiel->[0]) {
		print "Das Spiel fr diesen Spieltag wurde bereits eintragen!".br;
		return;
	}
	#$Members[$gegner] zurckgeben, da $gegner wegen $heimspiel getauscht sein knnte
	return ($Members[$gegner], $heimspiel);
}
sub SpielplanNeuesErgebnisMoeglichEinfach {
	
	my $FirstTeamID = shift || return(0,0);
	my $Opponent = shift || return(0,0);
	my $AnzahlTeams = SpielplanTeamAnzahlLaden();
	my %Members = Members();
#	old:
#	my @Members = (sort {$a<=>$b} keys %Members);
#   new:
	my @Members = SpielplanTeamSortierungLaden();
	
	my $team=0;
	while($Members[$team] ne $FirstTeamID  && $team < $AnzahlTeams) {
		$team++;
	}
	if ($team >= $AnzahlTeams) { 
		print "Es konnte kein Gegner fr diesen Spieltag ermittelt werden! (nnme1)";
		return;
	}

	my $gegner=0;
	while($Members[$gegner] ne $Opponent  && $gegner < $AnzahlTeams) {
		$gegner++;
	}
	if ($gegner >= $AnzahlTeams) { 
		print "Es konnte kein Gegner fr diesen Spieltag ermittelt werden! (nnme2)";
		return;
	}

	my $Spiel1 = SpielplanErgebnisFuerAB($FirstTeamID, $Opponent);
	my $Spiel2 = SpielplanErgebnisFuerAB($Opponent, $FirstTeamID);
	my ($ok, $heimspiel) = (0,0);
	if ($Spiel1 || $Spiel2) {
		if ($LSC{LeagueData}{AnzahlSpiele} == 1) {
			print "Das Ergebnis gegen diesen Gegner wurde bereits eingetragen.".br;
			return;
		} elsif ($Spiel1 && $Spiel2) {
				print "Die Ergebnisse gegen diesen Gegner wurden bereits alle eingetragen".br;
				return;
		} elsif ($Spiel1) {
			($ok, $heimspiel) = (1,0);
		} elsif ($Spiel2) {
			($ok, $heimspiel) = (1,1);
		}
	} else {
		($ok, $heimspiel) = SpielplanSpieltagSpieltWo($team, $gegner);
		unless ($ok) {
			return;
		}
	}
	$team = $FirstTeamID ;
	my $gegner_ = $Members[$gegner];
#print "gegnernummer: $gegner, $heimspiel / $gegner_".br;
	
	unless ($heimspiel) {
		my $t = $team;
		$team = $gegner_;
		$gegner_ = $t;
	}
#	my $Spiel = SpielplanErgebnisFuerAB($team, $gegner_);
	#unless ($Spiel) {
	#	print "Fr diesen Spieltag kann kein Spiel eingetragen werden!".br;
	#	return;
	#}
#	if ($Spiel->[0]) {
#		print "Das Spiel fr diesen Spieltag wurde bereits eintragen!".br;
#		return;
#	}
	#$Members[$gegner] zurckgeben, da $gegner wegen $heimspiel getauscht sein knnte
	return ($Members[$gegner], $heimspiel);
}
sub SpielplanSpieltagBeschreibung {
	unless ($LSC{SpieltagBeschreibung}) {
		return "";
	}
	my $sth = $LSC{MySQL}->prepare("SELECT Beschreibung FROM lsc_leagues_spieltag_name WHERE 
			League=$LSC{League} and Spieltag=".($_[0] || 0));
	$sth->execute();
	my $r = $sth->fetchrow_arrayref();
	$sth->finish;	
	
	return $r->[0] || '';
}

1
