
###############################################################################
# Sources From LigaScript                                                     #
###############################################################################
# LigaScript: Online Ligaverwaltung                                           #
#                                                                             #
# Version:        LigaScript Full Version 2.1.0	                              #
# First-Released: August 1999                                                 #
# Distributed by: http://www.scroax.net                                       #
# =========================================================================== #
# Copyright (c) 2004 Joerg Nass (www.scroax.net) - All Rights Reserved.	      #
# Software by: Joerg Nass                                                     #
# Kontaktinformationen und weiteres sind jeweils auf den angebenen            #
# Homepages zu finden!                                                        #
###############################################################################
#  ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!!                #
#  Bitte den Disclaimer und die Nutzungsbedingungen in der Datei              #
#  LSCConfig.pm lesen!                                                        #
#                                                                             #
###############################################################################




## mehrere Ligen:
# TeamPunkteGesamt
# TeamHomeRoadBilanz
# TeamLast10Games
# TeamHoechsterSieg
# TeamHoechsteNiederlage
# TeamMeistenPunkte
# TeamWenigstenPunkte
# TeamLongestStreak

## Statistikhilfsfunktionen

# TeamPunkteGesamt
# TeamHomeRoadBilanz
# TeamLast10Games
# TeamHoechsterSieg
# TeamHoechsteNiederlage
# TeamMeistenPunkte
# TeamWenigstenPunkte
# TeamLongestStreak

sub TeamPunkteGesamt {
	#TeamID, League
	my ($select,$from,$where,$group,$order);

	$select	= "SUM(G1.Points) as SumTPoints, SUM(G2.Points) as SumOPoints, SUM(G1.LP) as SumLPoints";
	$select	.= ",AVG(G1.Points) as AVGTPoints, AVG(G2.Points) as AVGOPoints";
	$select .= ", SUM(G1.Won) as SumWon, SUM(G1.Lost) as SumLost, SUM(G1.Draw) as SumDraw,
		 Count(G1.Team) as Total";

	$from	= $Select{Game}{From}." ".$Select{Game}{JoinG2};
	$where	= "G1.Team=$_[0] and $Select{Game}{Where}";
			$where =~s/\#LEAGUE/$_[1]/gg;

	$group	= "Group by G1.Team";
	$order	= "";
	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");
	$sth->execute();
	my $ref = $sth->fetchrow_hashref();
	$sth->finish;
	return $ref
}
sub TeamHomeRoadBilanz {
	#TeamId, GesamtSiege, GesamtNiederlagen, League
	my ($select,$from,$where,$group,$order);
		$select	= "SUM(G1.Won) as W, SUM(G1.Lost) as L, SUM(G1.Draw) as D";

	$from	= $Select{Game}{From}." ".$Select{Game}{JoinG2};
	$where	= "$Select{Game}{WhereHome} and G1.Team=$_[0]";
		$where =~s/\#LEAGUE/$_[3]/gg;

	$group	= "Group by G1.Team";
	$order	= "";

	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");
	$sth->execute();
	my $ref = $sth->fetchrow_hashref();
	$sth->finish;

	my $won		= $ref->{'W'} || 0;
	my $lost	= $ref->{'L'} || 0;
	my $draw	= $ref->{'D'} || 0;
	if ($_[5]) {
		#unentschieden
		return ("$won:$lost:$draw", ($_[1]-$won).":".($_[2]-$lost).":".($_[5]-$draw));
	}
	return ("$won:$lost", ($_[1]-$won).":".($_[2]-$lost));
}
sub TeamLast10Games {
	#TeamId, League, Draw
	unless($_[0]) {
		return;
	}
	my ($select,$from,$where,$group,$order);
		$select	= "G1.Won, G1.Lost";
		$from	= $Select{Game}{From};	
		$from .= " ".$Select{Game}{JoinG2};
		
		$where	= $Select{Game}{Where}." and G1.Team=$_[0]";
		$where =~s/\#LEAGUE/$_[1]/gg;

		$group	= "";
		$order	= "Order by D.Date DESC Limit 10";
	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");
	$sth->execute();
	my ($won, $lost, $draw) = (0,0,0);
	while (my $ref = $sth->fetchrow_arrayref()) {
		if ($ref->[0]) {
			$won++;
		} elsif ($ref->[1]){
			$lost++;
		} else {
			$draw++;
		}
	}
	$sth->finish;
	
#############
############# nochmal angucken !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#############	

	if ($_[2]) {
		if ($draw) {
			$draw = "$draw:";
		} else {
			$draw = '0:';
		}
		return "$won:$draw$lost";
	}
	return ($won, $lost);
}
sub TeamHoechsterSieg {
	#TeamID, League
	my ($select,$from,$where,$group,$order);
	$select	= "T.Name as Gegner, G2.Team as GegnerID, 
	G1.Points as TPoints, G2.Points as OPoints, G1.Game, G1.ID - G2.ID as H, G1.Points - G2.Points as MaxDifference, 
	DATE_FORMAT(D.Date,'%d. %M %Y') as Datum";
	$from	= $Select{Game}{From};
	$from .= " $Select{Game}{JoinG2}";
	$from .= " $Select{Game}{JoinTeam2}";
	$where	= "G1.Team=$_[0] and $Select{Game}{Where} and G1.Won=1 
		and (G1.Points - G2.Points) > 0";
	$where =~s/\#LEAGUE/$_[1]/gg;


	$group	= "";
	$order	= "Order by MaxDifference DESC, G2.Points DESC Limit 1";
#print "SELECT $select FROM $from WHERE $where $group $order".br;
	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");
	$sth->execute();
	my $ref = $sth->fetchrow_hashref();
	$sth->finish;
	return $ref
}
sub TeamHoechsteNiederlage {
	#TeamID, League
	my ($select,$from,$where,$group,$order);

	$select	= "T.Name as Gegner, G2.Team as GegnerID, 
	G1.Points as TPoints, G2.Points as OPoints, G1.Game, G1.ID - G2.ID as H, G1.Points - G2.Points as MaxDifference, 
	DATE_FORMAT(D.Date,'%d. %M %Y') as Datum";
	$from	= $Select{Game}{From};
	$from .= " $Select{Game}{JoinG2}";
	$from .= " $Select{Game}{JoinTeam2}";
	$where	= "G1.Team=$_[0] and $Select{Game}{Where} and G1.Lost=1 
		and (G1.Points - G2.Points) < 0";
	$where =~s/\#LEAGUE/$_[1]/gg;

	$group	= "";
	$order	= "Order by MaxDifference ASC, G1.Points ASC Limit 1";
	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");
	$sth->execute();
	my $ref = $sth->fetchrow_hashref();
	$sth->finish;
	return $ref
}
sub TeamMeistenPunkte {
	#TeamID, League
	my ($select,$from,$where,$group,$order);
		
	$select	= "T.Name as Gegner, G2.Team as GegnerID, 
		G1.Points as TPoints, G2.Points as OPoints, G1.Game, G1.ID - G2.ID as H, 
		DATE_FORMAT(D.Date,'%d. %M %Y') as Datum";
	$from	= $Select{Game}{From};
	$from .= " $Select{Game}{JoinG2}";
	$from .= " $Select{Game}{JoinTeam2}";

	$where	= "G1.Team=$_[0] and $Select{Game}{Where}";
	$where =~s/\#LEAGUE/$_[1]/gg;

	$group	= "";
	$order	= "Order by G1.Points DESC Limit 1";
	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");
	$sth->execute();
	my $ref = $sth->fetchrow_hashref();
	$sth->finish;
	return $ref
}	
sub TeamWenigstenPunkte {
	#TeamID, League
	my ($select,$from,$where,$group,$order);
	$select	= "T.Name as Gegner, G2.Team as GegnerID, 
		G1.Points as TPoints, G2.Points as OPoints, G1.Game, G1.ID - G2.ID as H, 
		DATE_FORMAT(D.Date,'%d. %M %Y') as Datum";
	$from	= $Select{Game}{From};
	$from .= " $Select{Game}{JoinG2}";
	$from .= " $Select{Game}{JoinTeam2}";

	$where	= "G1.Team=$_[0] and $Select{Game}{Where}";
	$where =~s/\#LEAGUE/$_[1]/gg;

	$group	= "";
	$order	= "Order by G1.Points ASC Limit 1";
	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");
	$sth->execute();
	my $ref = $sth->fetchrow_hashref();
	$sth->finish;
	return $ref
}
sub TeamLongestStreak {
	#TeamId, League
	my ($select,$from,$where,$group,$order);
		$select	= "G1.Won as W, G1.Lost as L";
		$from	= $Select{Game}{From};
		$where	= "G1.Team=$_[0] and $Select{Game}{Where}";
		$where =~s/\#LEAGUE/$_[1]/gg;
		$group	= "";
		$order	= "Order by D.Date ASC";
	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");
	$sth->execute();
	my $current = 0;
	my $count = 0;
	my @max = (0, 0, 0,0);
	while (my $ref = $sth->fetchrow_hashref()) {
		if ($ref->{'W'}) {
			if ($current == 1) {
				$count++
			} else {
				if ($count > $max[$current]) {
					$max[$current] = $count;
				}
				$current = 1;
				$count = 1;
			}
		} elsif ($ref->{'L'}) {
			if ($current == 2) {
				$count++
			} else {
				if ($count > $max[$current]) {
					$max[$current] = $count;
				}
				$current = 2;
				$count = 1;
			}
		} else {
			if ($current == 3) {
				$count++
			} else {
				if ($count > $max[$current]) {
					$max[$current] = $count;
				}
				$current = 3;
				$count = 1;
			}
		}
	}
	# letzte zhlung berprfen, ob lngste
	if ($count > $max[$current]) {
		$max[$current] = $count;
	}
	$sth->finish;
	return @max;
}

1
