
###############################################################################
# Sources From LigaScript                                                     #
###############################################################################
# LigaScript: Online Ligaverwaltung                                           #
#                                                                             #
# Version:        LigaScript Full Version 2.0.1 BETA!                         #
# First-Released: August 1999                                                 #
# Distributed by: http://leagues.ihoax.de                                     #
# =========================================================================== #
# Copyright (c) 2000-2003 Joerg Nass (www.ihoax.de) - All Rights Reserved.    #
# Software by: Joerg Nass                                                     #
# Kontaktinformationen und weiteres sind jeweils auf den angebenen            #
# Homepages zu finden!                                                        #
###############################################################################
#  ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!!                #
#  Bitte den Disclaimer und die Nutzungsbedingungen in der Datei              #
#  LSCConfig.pm lesen!                                                        #
#                                                                             #
###############################################################################




## Hilfsfunktionen
# einzelne Informationen aus der DB holen

## Allgemeine Funktionen
# User_Anzahl
# TeamInfo
# TeamHomepage

# - Team/User
# NameFromUserID
# UserFromTeam
# TeamMembers
# Teamvorhanden
# TeamnameVorhanden

## Funktionen fr mehrere Ligen
# LigaNamen
# Ligen_Anzahl
# Ligen_Anzahl_Offeneligen (Anzahl der nicht beendeten Ligen)
# OffeneLigen
# Members
# SpieldatenLaden
# GameTeamDatenLaden

# - Team/User
# TeamnameAndUserFromTeamIDAndLeague
# TeamGroups
# TeamVerwarnt
# UserVerwarnt

#####
## Allgemeine Funktionen
#####
sub User_Anzahl {
	my $sth = $LSC{MySQL}->prepare("SELECT Count(*) FROM lsc_user WHERE 1");
	$sth->execute();
	my $ref = $sth->fetchrow_arrayref();
	$sth->finish;
	return $ref->[0] || 0;
}
sub TeamInfo {
	my $team =shift;
	my $ori = shift || 0;
	if ($team=~/[^0-9]/) {
		return "Keine Informationen fr dieses Team vorhanden";
	}
	
	my $sth = $LSC{MySQL}->prepare("SELECT Info FROM lsc_teams WHERE ID=$team");
	$sth->execute();
	my $ref = $sth->fetchrow_arrayref();
	$sth->finish;
	return ($ref->[0] || "") if $ori;
	return $ref->[0] ? RemoveHtmlFromText($ref->[0]) : '';
}
sub TeamPassword {
	my $team =shift;
	if ($team=~/[^0-9]/) {
		return "";
	}
	
	my $sth = $LSC{MySQL}->prepare("SELECT Password FROM lsc_teams WHERE ID=$team");
	$sth->execute();
	my $ref = $sth->fetchrow_arrayref();
	$sth->finish;
	return $ref->[0] || '';
}
sub TeamImage {
	my $team =shift;
	if (!$team || $team=~/[^0-9]/) {
		return "";
	}
	my $sth = $LSC{MySQL}->prepare("SELECT Image1, Image2 FROM lsc_teams WHERE ID=$team");
	$sth->execute();
	my $ref = $sth->fetchrow_arrayref();
	$sth->finish;
	if ($ref->[0]) {
		$ref->[0] =~s/\</&lt/gg;
		$ref->[0] =~s/\>/&gt/gg;
	}
	if ($ref->[1]) {
		$ref->[1] =~s/\</&lt/gg;
		$ref->[1] =~s/\>/&gt/gg;
	}
	return ($ref->[0] || '',$ref->[1] || '');
}
sub TeamSpieltInLiga {
	my $team =shift;
	my $liga =shift || $LSC{League};
	if ($team=~/[^0-9]/) {
		return 0;
	}
	
	my $sth = $LSC{MySQL}->prepare("SELECT count(*) FROM lsc_teams_league WHERE Team=$team and League=".$LSC{MySQL}->quote($liga));
	$sth->execute();
	my $ref = $sth->fetchrow_arrayref();
	$sth->finish;
	return $ref->[0] || 0;

}
## - Team/User
sub NameFromUserID {
	unless ($_[0]) {return '';}
	my ($select,$from,$where);
	$select	= "Login";
	$from	= "lsc_user";
	$where	= "UserID=".$LSC{MySQL}->quote($_[0]);
	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where");
	$sth->execute();
	my $ref = $sth->fetchrow_arrayref();
	$sth->finish;
	unless ($ref) {
		return;
	}
	return $ref->[0];
}
sub UserIDFromName {
	unless ($_[0]) {return '';}
	my ($select,$from,$where);
	$select	= "UserID";
	$from	= "lsc_user";
	$where	= "Login=".$LSC{MySQL}->quote($_[0]);
	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where");
	$sth->execute();
	my $ref = $sth->fetchrow_arrayref();
	$sth->finish;
	unless ($ref) {
		return;
	}
	return $ref->[0];
}
sub AlleUserIDs {
	my $sth = $LSC{MySQL}->prepare("SELECT UserID FROM lsc_user WHERE 1");
	$sth->execute();
	my @users = ();
		foreach $u (@{$sth->fetchall_arrayref()}) {
		push @users, $u->[0];
	}
	$sth->finish;
	return @users;
}
sub AlleAdminIDs {
	my $sth = $LSC{MySQL}->prepare("SELECT User FROM lsc_leagues_admins WHERE 1 Group by User");
	$sth->execute();
	my %users = ();
		foreach $u (@{$sth->fetchall_arrayref()}) {
		$users{$u->[0]} = 1;
	}
	$sth->finish;
	$sth = $LSC{MySQL}->prepare("SELECT UserID FROM lsc_user WHERE Status >= 5 Group by UserID");
	$sth->execute();
		foreach $u (@{$sth->fetchall_arrayref()}) {
		$users{$u->[0]} = 1;
	}
	$sth->finish;
	return keys %users;
}
sub UserFromTeam {
	unless ($_[0]) {return '';}
	my ($select,$from,$where);
	$select	= "User";
	$from	= "lsc_teams";
	$where	= "ID=$_[0]";
	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where");
	$sth->execute();
	my $ref = $sth->fetchrow_arrayref();
	$sth->finish;
	unless ($ref) {
		return;
	}
	return $ref->[0];
}
sub TeamIDFromName {
	unless ($_[0]) {return '';}
	my ($select,$from,$where);
	$select	= "ID";
	$from	= "lsc_teams";
	$where	= "Name=".$LSC{MySQL}->quote($_[0]);
	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where");
	$sth->execute();
	my $ref = $sth->fetchrow_arrayref();
	$sth->finish;
	unless ($ref) {
		return;
	}
	return $ref->[0];
}
sub TeamMembers {
	my $sth = $LSC{MySQL}->prepare("SELECT U.UserID, U.Login, TM.Status, to_days(now())- to_days(TM.JoinDate)  FROM lsc_teams_members
	TM, lsc_user U WHERE TM.Team='$_[0]' and TM.Member=U.UserID");
	$sth->execute();
	my %members;
	my $c = 0;
	while(my $ref = $sth->fetchrow_arrayref()) {
		$c++;
		$members{$ref->[0]}{Name} = $ref->[1];
		$members{$ref->[0]}{Status} = $ref->[2];
		$members{$ref->[0]}{Date} = $ref->[3];
	}
	unless ($c) {
		return undef;
	}
	$sth->finish;
	return \%members;
}
sub TeamMembersEasy { 
	my $sth = $LSC{MySQL}->prepare("SELECT U.UserID, U.Login, TM.Status FROM lsc_teams_members
	TM, lsc_user U WHERE TM.Team='$_[0]' and TM.Member=U.UserID");
	$sth->execute();
	
	my %members;
	while(my $ref = $sth->fetchrow_arrayref()) {
		$members{$ref->[0]} = $ref->[1];
	}
	$sth->finish;
	return \%members;
}
sub TeamMemberCount { 
	my $sth = $LSC{MySQL}->prepare("SELECT count(*) FROM lsc_teams_members WHERE Team='$_[0]'");
	$sth->execute();
	
	my $ref = $sth->fetchrow_arrayref();
	$sth->finish;
	return $ref->[0] || 0;
}
sub Teamvorhanden {
	my ($select,$from,$where,$group,$order);
	my $id = $LSC{MySQL}->quote($_[0]);
	$select	= "count(*)";
	$from	= "lsc_teams";
	$where	= "ID=$id";
	$group	= "";
	$order	= "";
	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");
	$sth->execute();
	my $ref = $sth->fetchrow_arrayref();
	$sth->finish;
	return $ref->[0];
}

sub TeamnameVorhanden {
	my $Team = shift;
	unless ($Team) {
		return;
	}
	my ($select,$from,$where,$group,$order);
	my $name = $LSC{MySQL}->quote($Team);
	$select	= "count(*)";
	$from	= "lsc_teams";
	$where	= "Name=$name";
	$group	= "";
	$order	= "";
	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");
	$sth->execute();
	my $ref = $sth->fetchrow_arrayref();
	$sth->finish;
	return $ref->[0];
}



#####
## Funktionen fr mehrere Ligen
#####
sub LigaNamen {
	my $sth = $LSC{MySQL}->prepare("SELECT Name, League FROM lsc_leagues WHERE 1");
	$sth->execute();
	my %L;
	while (my $ref = $sth->fetchrow_arrayref()) {
		$L{$ref->[1]} = $ref->[0];
	}
	$sth->finish;
	return %L;
}
sub LigaName {
	my $sth;
	if ($LSC{sth}{LigaName}) {
		$sth = $LSC{sth}{LigaName};
	} else {
		$LSC{sth}{LigaName} = $LSC{MySQL}->prepare("SELECT Name FROM lsc_leagues WHERE League=?");
		$sth = $LSC{sth}{LigaName};
	}
	$sth->execute($_[0]);
	my $ref = $sth->fetchrow_arrayref();
	$sth->finish;
	return $ref->[0] || "";
}
sub Ligen_Anzahl {
	my $sth = $LSC{MySQL}->prepare("SELECT Count(*) FROM lsc_leagues WHERE 1");
	$sth->execute();
	my $ref = $sth->fetchrow_arrayref();
	$sth->finish;
	return $ref->[0] || 0;
}
sub Ligen_Anzahl_Offeneligen {
	my %T = OffeneLigen();
	return (keys %T)/1;
}	
sub LigaLetztesErgebnisVorXTagen {
	my $League = shift || $LSC{League} || return -1;
	my $sth = $LSC{MySQL}->prepare("SELECT min(to_days(now()) - to_days(Date)) FROM lsc_games_daten WHERE League=".$League);
	$sth->execute();
	
	my $ref = $sth->fetchrow_arrayref();
	$sth->finish;

	return $ref->[0] || 0;

}
sub OffeneLigen {
	my %Leagues;
	my $sth = $LSC{MySQL}->prepare("SELECT League, Name FROM lsc_leagues WHERE Status=1");
	$sth->execute();
	
	while (my $ref = $sth->fetchrow_arrayref()) {
			$Leagues{$ref->[0]} = $ref->[1];
	}
	$sth->finish;
	return %Leagues;
}
sub Members {
	my $League=shift || $LSC{League};
	my ($select,$from,$where,$group,$order);
	$select	= "T.ID, T.Name";
	$from	= "lsc_teams T, lsc_teams_league L";
	$where	= "T.ID=L.Team and L.League=$League";
	$group	= "";
	$order	= "Order by T.Name";

	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");
	$sth->execute();
	my %Members;
	while (my $ref = $sth->fetchrow_arrayref()) {
		$Members{$ref->[0]} = $ref->[1];
	}
	$sth->finish;
	return %Members;
}
sub SpieldatenLaden {
	my $Spielnummer = shift || return;
	my $Liga = shift || $LSC{League};
	if ($Spielnummer=~/[^0-9]/) {
		return;
	}
	my ($select,$from,$where,$group,$order);
		$select	= "G1.Game, G1.Team, G2.Team, T1.Name, T2.Name, G1.Points, G2.Points, D.Special, 
		DATE_FORMAT(D.Date,'%e. %M %Y'), 
		G1.Won, G1.Lost, G1.Draw, D.League, D.PogName,
		G1.PPoints1, G1.PPoints2, G1.LP, G1.Map, G1.Vote,
		G2.PPoints1, G2.PPoints2, G2.LP, G2.Map, G2.Vote,
		DATE_FORMAT(D.Date,'%m/%e/%y')
		";
		$from	= "lsc_games_daten D, lsc_games G1, lsc_teams T1";
		$from .= " LEFT JOIN lsc_games G2 ON G1.Game = G2.Game and G1.ID != G2.ID";
		$from .= " LEFT JOIN lsc_teams T2 on G2.Team=T2.ID";
		$where	= "D.No=$Spielnummer and D.League=$Liga and D.No=G1.Game and G1.Team=T1.ID and G1.Home>0";
		$group	= "";
		$order	= "";
#print 	br."SELECT $select FROM $from WHERE $where $group $order".br;
	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");
	$sth->execute();
	my %Leagues;
	my $ref = $sth->fetchrow_arrayref();
	$sth->finish;
	return $ref if ($ref && $ref->[0]);
	return;
}
sub GameTeamDatenLaden {
	my $GameID = shift;
	my ($select,$from,$where,$group,$order);
	
	$select	= "ID, Game, Team, Points, LP, Won, Lost, Draw";
	$from	= "lsc_games";
	$where	= "Game=$GameID";
	$group	= "";
	$order	= "Order by Game";
	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");
	$sth->execute();
	my %Leagues;
	my $T1 = $sth->fetchrow_hashref();
	my $T2 = $sth->fetchrow_hashref();
	$sth->finish;
	return ($T1, $T2);
}
##	Team/User ##	
sub TeamnameAndUserFromTeamIDAndLeague {
	unless ($_[0] && $_[1]) {
		return;
	}

	my $sth;

	if ($LSC{sth}{TeamnameAndUserFromTeamIDAndLeague}) {
		$sth = $LSC{sth}{TeamnameAndUserFromTeamIDAndLeague};
	} else {
		$LSC{sth}{TeamnameAndUserFromTeamIDAndLeague} = $LSC{MySQL}->prepare("SELECT T.Name, T.User, T.Status FROM lsc_teams T, lsc_teams_league L WHERE L.Team=? and L.League=? and L.Team=T.ID");
		$sth = $LSC{sth}{TeamnameAndUserFromTeamIDAndLeague};
	}

	$sth->execute($_[0], $_[1]);
	my $ref = $sth->fetchrow_arrayref();
	$sth->finish;
	unless ($ref) {
		return;
	}
	return ($ref->[0], $ref->[1], $ref->[2]);
}		
sub TeamnameAndUserFromTeamID {
	unless ($_[0]) {
		return;
	}
	if ($_[1]) {
		return TeamnameAndUserFromTeamIDAndLeague($_[0],$_[1]);
	}
	
	if ($LSC{sth}{TeamnameAndUserFromTeamID}) {
		$sth = $LSC{sth}{TeamnameAndUserFromTeamID};
	} else {
		$LSC{sth}{TeamnameAndUserFromTeamID} = $LSC{MySQL}->prepare("SELECT T.Name, T.User, T.Status FROM lsc_teams T WHERE T.ID=?");
		$sth = $LSC{sth}{TeamnameAndUserFromTeamID};
	}
	$sth->execute($_[0]);
	my $ref = $sth->fetchrow_arrayref();
	$sth->finish;
	unless ($ref) {
		return;
	}
	return ($ref->[0], $ref->[1], $ref->[2]);
}		
sub TeamGroups {
	my ($select,$from,$where,$group,$order);
	$select	= "ID, Name";
	$from	= "lsc_teams_groups";
	$where	= "1";
	$group	= "";
	$order	= "Order by Name";

	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");
	$sth->execute();
	my %Members;
	while (my $ref = $sth->fetchrow_arrayref()) {
		$Members{$ref->[0]} = $ref->[1];
	}
	$sth->finish;
	return %Members;
}
sub TeamVerwarnt {
	my $League=$_[1] || $LSC{League} || 0;
	unless ($League) {
		return "";
	}
	my $id = $LSC{MySQL}->quote($_[0]);
	my ($select,$from,$where,$group,$order);
	$select	= "Text";
	$from	= "lsc_teams_gelb";
	$where	= "League=$League and Team=$id";
	$group	= "";
	$order	= "";

	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");
	$sth->execute();
	my $ref = $sth->fetchrow_arrayref();
	$sth->finish;
	
	return $ref->[0] ? $ref->[0] : "";
}
sub UserVerwarnt {
	my $League = $_[1] || $LSC{League};
	my $id = $LSC{MySQL}->quote($_[0]);
	
	my ($select,$from,$where,$group,$order);
	$select	= "Status";
	$from	= "lsc_user";
	$where	= "UserID=$id";
	$group	= "";
	$order	= "";
	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");
	$sth->execute();
	my $ref2 = $sth->fetchrow_arrayref();
	$sth->finish;

	unless ($League) {
		return (0, (($ref2->[0] && $ref2->[0] == 2) ? 1 : 0));
	}
	$select	= "Text";
	$from	= "lsc_user_gelb";
	$where	= "League=$League and User=$id";
	$sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");
	$sth->execute();
	my $ref = $sth->fetchrow_arrayref();
	$sth->finish;

	return (($ref->[0] ? $ref->[0] : 0), (($ref2->[0] && $ref2->[0] == 2) ? 1 : 0));
}

#############

sub MapListe {
	unless ($LSC{League}) {
		return undef;
	}


	my $sth = $LSC{MySQL}->prepare("SELECT ID, Name FROM lsc_leagues_maps WHERE League=$LSC{League}");
	$sth->execute();
	my %maps = ();
	while (my $ref = $sth->fetchrow_arrayref()) {
		$maps{$ref->[0]} = $ref->[1] if $ref->[0] && $ref->[1];
	}
	$sth->finish;
	
	return %maps;
}
1
