
###############################################################################
# Sources From LigaScript                                                     #
###############################################################################
# LigaScript: Online Ligaverwaltung                                           #
#                                                                             #
# Version:        LigaScript Full Version 2.0.1 BETA!                         #
# First-Released: August 1999                                                 #
# Distributed by: http://leagues.ihoax.de                                     #
# =========================================================================== #
# Copyright (c) 2000-2003 Joerg Nass (www.ihoax.de) - All Rights Reserved.    #
# Software by: Joerg Nass                                                     #
# Kontaktinformationen und weiteres sind jeweils auf den angebenen            #
# Homepages zu finden!                                                        #
###############################################################################
#  ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!!                #
#  Bitte den Disclaimer und die Nutzungsbedingungen in der Datei              #
#  LSCConfig.pm lesen!                                                        #
#                                                                             #
###############################################################################


sub UserDatenSpeichern {
	unless ($_[0]) {
		return;
	}
	
	my @set;
	if ($_[1]->{Email}) {
		my $User = UserVonEmailAdresse($_[1]->{Email});
		if (!$User || $User == $_[0]) {
			push (@set, "Email=".$LSC{MySQL}->quote($_[1]->{Email}));
		} else {
			print "Die Emailadresse wird bereits von einem anderen Account benutzt!".br;
		}
	}
	if ($_[1]->{Login}) {
		#auf doppelte namen prfen
		my $checkuser = UserIDFromName($_[1]->{Login});
		if ($checkuser) {
			if ($checkuser != $_[0]) {
				print "Der Name ".$_[1]->{Login}." wird bereits benutzt".br;
			}
		} else {
			push (@set, "Login=".$LSC{MySQL}->quote($_[1]->{Login}));
		}
	}
	if (defined $_[1]->{ICQ}) {
		push (@set, "ICQ=".$LSC{MySQL}->quote($_[1]->{ICQ}));
	}
	if ($_[1]->{Status}) {
		push (@set, "Status=".$LSC{MySQL}->quote($_[1]->{Status}));
	}

	if ($_[1]->{WonID} && $_[1]->{WonIDText}) {
		my $user = UserDatenFromUserID($_[0]);
		my $t = "[old: $user->{WonID}] ".$_[1]->{WonIDText};
		$t =~s/\<.*\>//gg;
		push (@set, "WonID=".$LSC{MySQL}->quote($_[1]->{WonID}));

		#alte log lschen
		$sth = $LSC{MySQL}->do("delete from lsc_user_wonid_log where UserID=$_[0]");

		$sth = $LSC{MySQL}->do("insert into lsc_user_wonid_log (UserID,
		Text) Values ($_[0],".$LSC{MySQL}->quote($t).")");
	}
	
	if ($_[1]->{Birthday}) {
		if ($_[1]->{Birthday}[0] || $_[1]->{Birthday}[1] ||
		($_[1]->{Birthday}[2] && $_[1]->{Birthday}[2] > 1900)) {

			push (@set, "birthday=".$LSC{MySQL}->quote(
			($_[1]->{Birthday}[2] > 19 ? $_[1]->{Birthday}[2] :"0000").
			"-".
			($_[1]->{Birthday}[1] || "00").
			"-".			
			($_[1]->{Birthday}[0] || '00')));

		}
	}

	if ($set[0]) {
		my $sth = $LSC{MySQL}->do("update lsc_user set ".join(',', @set)."
		where UserID=$_[0]");
	}	

}

######
## Team
######

sub TeamInfoBearbeiten {
	my ($action, $Team, $First) = @_;
	print "<div class=Headline>".
			($First ? $LSC{TEXT}{User}[19]:$LSC{TEXT}{User}[18]).
			"</div>".br.br;

	my $Teams = TeamsEinesUsers($LSC{userid});
	my $FirstTeam= FirstUserTeamID($LSC{userid});

	unless ($Team) {
		print "<div class=Headline>$LSC{TEXT}{User}[20]:</div>".br;
		
		foreach my $T (@{$Teams}) {
			if ($FirstTeam eq $T->[0]) {
				#print '[First/Standard-Team]';
			} else {
				print "<a class=Team href=$scriptname?League=$LSC{League}&Action=TeamInfo&special=$T->[0]>(ID: $T->[0]) $T->[1]</a>";
				print br;
			}
		}
		return;
	}
	my ($TeamName, undef) = TeamnameAndUserFromTeamID($Team);
	print "<div class=Headline>Name: $TeamName</div>" if !$First;

	if ($LSC{UserStatus} == 9) {
			print "<div class=Headline><br>ADMIN MOD<br><br></div>";
	} else {
		my $ok = 0;
		foreach my $T (@{$Teams}) {
			if ($T->[0] eq $Team) {
				$ok++;
			}
		}
		if (!$ok) {
			#Dieses Team gehrt dir nicht!
			print $LSC{TEXT}{Error}[1].br;
			return;
		}
	}

		if ($action eq 'NewMember' && $Team ne $FirstTeam) {
			print $LSC{TEXT}{User}[21].br;
			my $id;
			if (($id=TeamSuchen($scriptname, 'TeamInfo&Action2=NewMember&special='.$Team, 2))) {
				UserZuTeamAlsMember($Team, $id);
				print $LSC{TEXT}{User}[22];
			}
			print hr;
		}
		if ($action eq  'MemberStatus' && $Team ne $FirstTeam) {
				if ($q->param('Member')=~/[^0-9]/) {
					print $LSC{TEXT}{Error}[2].br;
				} else {
					if (($q->param('Status-'.($q->param('Member')||''))||'') eq '100') {
						UserAusTeamAlsMemberLoeschen($q->param('Member'), $Team);
						print $LSC{TEXT}{User}[23];
					} else {
						if (defined($q->param('Status-'.($q->param('Member')||'')))) {
							my $status = $LSC{MySQL}->quote("".($q->param('Status-'.($q->param('Member')||''))||''));
							my $do = "update lsc_teams_members set Status=$status where Team='$Team'
								and Member='".$q->param('Member')."'";
							my $sth = $LSC{MySQL}->do($do);
							print $LSC{TEXT}{User}[28];
						}
					}
				}
		print hr;
		}
		
		if ($action eq  'NewDat') {
			if ($Team ne $FirstTeam) {
				if ($LSC{TeamNameAenderbar} && $q->param('TeamName') && TeamnameOK($q->param('TeamName'), $Team)) {
					TeamZusatzDatenSpeichern($Team, {
						Url =>($q->param('Homepage')||""),
						Image =>($q->param('Image')||""),
						Image2 =>($q->param('Image2')||""),
						Irc =>($q->param('IRC')||""),
						TeamKurz=>($q->param('TeamKurz')||""),
						TeamName=>($q->param('TeamName')||""),
						TeamPW=>($q->param('TeamPW')||""),
						Status=>($q->param('Status')||""),
						TeamOwner=>($q->param('TeamOwner')||""),
					});
				} elsif (1) {
					TeamZusatzDatenSpeichern($Team, {
						Url =>($q->param('Homepage')||""),
						Image =>($q->param('Image')||""),
						Image2 =>($q->param('Image2')||""),
						Irc =>($q->param('IRC')||""),
						TeamKurz=>($q->param('TeamKurz')||""),
						TeamPW=>($q->param('TeamPW')||""),
						Status=>($q->param('Status')||""),
						TeamOwner=>($q->param('TeamOwner')||""),
					});
				}
			} else {
				TeamZusatzDatenSpeichern($Team, {
						Url =>($q->param('Homepage')||""),
						Image =>($q->param('Image')||""),
						Image2 =>($q->param('Image2')||""),
						Irc =>($q->param('IRC')||""),
						TeamKurz=>''
					});
				#	TeamName=>($q->param('TeamName')||""),
			}
		print hr;
		}
		if ($action eq  'NewComment') {
			TeamZusatzDatenSpeichern($Team, { Info =>$q->param('Info')});
		print hr;
		}
	if ($Team ne $FirstTeam) {
		print "<div class=Headline>$LSC{TEXT}{User}[24]:</div>".br;
		my ($select,$from,$where,$group,$order);
			$select	= "U.UserID, U.Login, TM.Status";
			$from	= "lsc_teams_members TM, lsc_user U";
			$where	= "TM.Team='$Team' and TM.Member=U.UserID order by TM.Status desc, U.Login";
		
		my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where");
		$sth->execute();
		
		while(my $ref = $sth->fetchrow_arrayref()) {
			$q->delete('Member');
			print $q->start_form('post',"$scriptname?League=$LSC{League}&Action=TeamInfo&Action2=MemberStatus&special=$Team");
			print $q->hidden('Member', $ref->[0]);
			print "$ref->[0]: ".UserLink($ref->[1], $ref->[0])." &nbsp;&nbsp;";
			print $q->popup_menu(-name=>'Status-'.$ref->[0], -values=>[keys %{$LSC{MemberStatus}}], -default=>$ref->[2], -labels=>$LSC{MemberStatus});
			print $q->submit('Member Status aendern'),$q->end_form();
		}
		$sth->finish;
		print $LSC{TEXT}{User}[25].br; #info zu dem user status
		print br;
		print $q->start_form('post',"$scriptname?League=$LSC{League}&Action=TeamInfo&Action2=NewMember&special=$Team");
		print $q->submit($LSC{TEXT}{User}[26]),$q->end_form();
		print hr;
	}
	
	
	print "<div class=Headline><b>$LSC{TEXT}{User}[27]:</b></div>".br if !First;	
	
	my $TeamDaten = TeamDatenLaden($Team);

	$values->{"LSC-TeamInfo"}		= RemoveHtmlFromText($TeamDaten->{Info});

	my $hp = $TeamDaten->{Homepage};
	my $irc = $TeamDaten->{IRC} || '#';
	my $kurz = $TeamDaten->{TAG};
	my $tpassword = $TeamDaten->{Password};
	$q->delete('TeamPW');
	my ($image, $image2) = ($TeamDaten->{Image1}, $TeamDaten->{Image2});
	print    $q->start_form('post',"$scriptname?League=$LSC{League}&Action=TeamInfo&Action2=NewDat&special=$Team");
	print "<table width=100%>";

	if ($LSC{UserStatus} == 9) {
		my $s = TeamStatus($Team);	
		print "<tr>
				<td class=Standard><b>Status:</b> 
				</td>
				<td class=Standard>".$q->popup_menu(-name=>'Status', -values=>[0,1], -default=>$s, 
			-labels=>{0 => 'normal',
				1 => 'gesperrt'})."</td>
			</tr>";
	}
	print "<tr>
			<td class=Standard><b>TeamID:</b>
			</td>
			<td class=Standard>".$Team."</td>
		</tr>";
	if ($LSC{UserStatus} == 9 || $LSC{TeamNameAenderbar}) {
		print "<tr>
				<td class=Standard><b>Name:</b>
				</td>
				<td class=Standard>".$q->textfield('TeamName',$TeamName,30,30)."</td>
			</tr>";
	}
	print "<tr>
			<td class=Standard><b>Homepage:</b>
			</td>
			<td class=Standard>".$q->textfield('Homepage',$hp,50,50)."</td>
		</tr>";
	if ($LSC{UserStatus} == 9) {
		print "<tr>
				<td class=Standard><b>Logo/Bild (Kann nur vom Admin festgelegt werden!s):</b>
				</td>
				<td class=Standard>".$q->textfield('Image',$image,50,100)."</td>
			</tr>";
	}
	print "<tr>
			<td class=Standard><b>Logo/Bild (Gre: 100*100 Pixel):</b>
			</td>
			<td class=Standard>".$q->textfield('Image2',$image2,50,100)."</td>
		</tr>";
	print "<tr>
			<td class=Standard><b>IRC-Channel:</b>
			</td>
			<td class=Standard>".$q->textfield('IRC',$irc,25,25)."</td>
		</tr>";
	print "<tr>
			<td class=Standard><b>Tag: </b>
			</td>
			<td class=Standard>".$q->textfield('TeamKurz',$kurz,25,25)."</td>
		</tr>";
	print "<tr>
			<td class=Standard><b>Password: (max. 6 Zeichen)</b><br>(Zum joinen des Teams und $LSC{TEXT}{Teamname2}-Internen Dingen)
			</td>
			<td class=Standard>".$q->textfield('TeamPW',$tpassword,8,6)."</td>
		</tr>";
		
	my $TMembers = TeamMembersEasy($Team);
		$TMembers->{0} = " ";
	if ($LSC{UserStatus} == 9) {
		$TMembers->{-1} = "delete Owner";
	}

	my $NameOwner = "";
	if ($TeamDaten->{User}) {
		my ($Name, undef) = UserNameUndStatusVonID($TeamDaten->{User});
		if ($Name) {
			$NameOwner = UserLink($Name, $TeamDaten->{User});
		} else {
			$NameOwner = "&ltunknown&gt";
		}
	} else {
		$NameOwner = "&ltnone&gt";
	}

	
	print "<tr>
			<td class=Standard><b>$LSC{TEXT}{Teamname2}-Owner $LSC{TEXT}{default}[4]: </b><br>(Kann nur vom aktuellen $LSC{TEXT}{Teamname2}-Owner verndert werden)<br>
			Current: $NameOwner
			</td>
			<td class=Standard>".$q->popup_menu(-name=>'TeamOwner', -values=>[keys %$TMembers], -default=>0, 
			-labels=>$TMembers)."</td>
		</tr>";

	print "<tr>
			<td class=Standard>
			</td>
			<td class=Standard>".$q->submit('speichern').$q->end_form()."</td>
		</tr>";
	
	#ligastatus
	if ($q->param('inaktiv') && $LSC{Admin}) {
		TeamLigaStatusSpeichern($Team, $LSC{League}, 1);
	}
	if ($q->param('aktiv') && $LSC{Admin}) {
		TeamLigaStatusSpeichern($Team, $LSC{League}, 0);
	}
	my %Ligen = AlleLigenInDenenTeamSpielt($Team);
	foreach my $L (sort keys %Ligen) {
		my $status = TeamLigaStatus($Team, $Ligen{$L});
		if ($status==0) {
			#aktiv
			print "<tr>
					<td class=Standard><FONT COLOR=\"#33FF00\">aktiv</FONT> ".TeamLink($L, $Team, '', 1, $Ligen{$L})."
					</td>
					".($LSC{UserStatus} == 9 || ($LSC{Admin} && $Ligen{$L} == $LSC{League}) ?
					"<td class=Standard>".$q->start_form('post',"$LSC{user_pl}?League=$Ligen{$L}&Action=TeamInfo&special=$Team").
										$q->submit('inaktiv').$q->end_form()."</td>" : "")."
				</tr>";
		} elsif ($status==1) {
			#inaktiv
			print "<tr>
					<td class=Standard><FONT COLOR=\"#FF0000\">inaktiv</FONT> ".TeamLink($L, $Team, '', 1, $Ligen{$L})."
					</td>
					".($LSC{UserStatus} == 9 || ($LSC{Admin} && $Ligen{$L} == $LSC{League})  ?
					"<td class=Standard>".$q->start_form('post',"$LSC{user_pl}?League=$Ligen{$L}&Action=TeamInfo&special=$Team").
										$q->submit('aktiv').$q->end_form()."</td>" : "")."
				</tr>";
		}
	}
#TeamLigaStatus
	print "</table>";
	
	
	print "<b>Team Kommentar:</b>".br;		
	
	print "Hier kannst du eine Kurze Information zu deinem Clan/Team einfgen:".br;
	print    $q->start_form('post',"$scriptname?League=$LSC{League}&Action=TeamInfo&Action2=NewComment&special=$Team");
	print	$q->textarea('Info',TeamInfo($Team, 1),5,50),br,br,$q->submit('speichern'),$q->end_form();
		
}

sub TeamZusatzDatenSpeichern {
	unless ($_[0]) {
		return;
	}
	my $Team = $_[0];
	my @Update = ();
	if (defined $_[1]->{Info}) {
		push @Update, "Info=".$LSC{MySQL}->quote($_[1]->{Info});
		print "Team-Info wurde gespeichert.".br;
	}
	if (defined $_[1]->{Irc}) {
		if ($_[1]->{Irc} ne '#') {
			push @Update, "IRC=".$LSC{MySQL}->quote($_[1]->{Irc});
			print " IRC-Channel wurde gespeichert.".br;
		}
	}
	if (defined $_[1]->{Url}) {
		push @Update, "Homepage=".$LSC{MySQL}->quote($_[1]->{Url});
		print "Homepage wurde gespeichert.".br;
	}
	if (defined $_[1]->{Image} && $LSC{Admin}) {
		push @Update, "Image1=".$LSC{MySQL}->quote($_[1]->{Image} || "");
		print "Logo/Bild wurde gespeichert.".br;
	}
	if (defined $_[1]->{Image2}) {
		push @Update, "Image2=".$LSC{MySQL}->quote($_[1]->{Image2} || "");
		print "Logo/Bild wurde gespeichert.".br;
	}
	if (defined $_[1]->{TeamKurz}) {
		push @Update, "TAG=".$LSC{MySQL}->quote($_[1]->{TeamKurz} || "");
		print "ClanTag wurde gespeichert.".br;
	}
	if ($_[1]->{TeamPW} && (IstLeaderVonTeam($LSC{userid},$Team) || $LSC{UserStatus} == 9)) {
		my $text = $LSC{MySQL}->quote($_[1]->{TeamPW});
		my $do = "update lsc_teams set Password=$text where ID='$Team'";
		my $sth = $LSC{MySQL}->do($do);
		print "Password wurde gespeichert.".br;
	}

	if (defined $_[1]->{TeamOwner} && (IstLeaderVonTeam($LSC{userid},$Team) || $LSC{UserStatus} == 9)) {
		if ($_[1]->{TeamOwner} !~/[^0-9\-]/ && 
				($_[1]->{TeamOwner} > 0 || ($_[1]->{TeamOwner} == -1 && $LSC{UserStatus} == 9))
			) {
			my $text = $LSC{MySQL}->quote($_[1]->{TeamOwner} > 0 ? $_[1]->{TeamOwner} : 0);
			my $do = "update lsc_teams set User=$text where ID='$Team' and (User=$LSC{userid} or $LSC{UserStatus}=9)";
			my $sth = $LSC{MySQL}->prepare($do);
			$sth->execute();

			print "Der Besitzer des Teams wurde gendert.".br if $sth->rows;
		}
	}
	if ($_[1]->{TeamName} && ($LSC{UserStatus} == 9 || $LSC{TeamNameAenderbar})) {
		my $checkteam = TeamIDFromName($_[1]->{TeamName});
		if ($checkteam) {
			if ($checkteam != $_[0]) {
				print "Der Name ".$_[1]->{Login}." wird bereits benutzt".br;
			}
		} else {
			push @Update, "Name=".$LSC{MySQL}->quote($_[1]->{TeamName} || "");
			print "Teamname wurde gespeichert.".br;
		}
	}
	if (defined($_[1]->{Status}) && $LSC{UserStatus} == 9) {
		my $text = $LSC{MySQL}->quote($_[1]->{Status});
		my $do = "update lsc_teams set Status=$text where ID='$Team'";
		my $sth = $LSC{MySQL}->do($do);
		print "Teamstatus wurde gespeichert.".br;
	}
	
	if ($Update[0]) {
		my $set = join(", ", @Update);
		my $do = "update lsc_teams set $set where ID='$Team'";
		my $sth = $LSC{MySQL}->do($do);
	}
}
sub TeamLigaStatusSpeichern {
	my $Team = $LSC{MySQL}->quote(shift || return);
	my $League = shift;
	my $Status = shift;
	my $do = "update lsc_teams_league set Status=$Status where Team=$Team and League=$League";
	my $sth = $LSC{MySQL}->do($do);
}
sub UserZuTeamAlsMember {
	my ($Team, $User) = @_;
	my $Mem = TeamMembersEasy($Team);
	if ($Mem->{$User}) {
		return;
	}
	my $do = "replace lsc_teams_members (Team, Member, Status, JoinDate) 
					Values ('$_[0]', '".$_[1]."', 0, Now())";
	my $sth = $LSC{MySQL}->prepare($do);
	$sth->execute();
	$sth->finish;

	my ($Teamname, undef) = TeamnameAndUserFromTeamID($Team);
	if ($User eq $LSC{userid}) {
		#teile leader mit, das member dem team beigetreten ist
		my @user = LeaderEinesTeams($Team);
		my $Send = SendMessage(
					{	Email=>0, Intern=>1, 
						System=>1, 
						To=>[@user], From=>0, 
						ToEmail=>"", FromEmail=>"", 
						DeleteAfterXDays=>$LSC{Messages}{DeleteInfo}, 
						Subject=>$LSC{TEXT}{Email}[11], 
						Message=>"", 
						Template=>$LSC{TEXT}{Email}[14], 
						TemplateValues=>{MEMBER=>$LSC{username}, TEAM=>$Teamname,
								TEAMLINK=>$LSC{ScriptURL}."$LSC{user_pl}?Action=TeamStatistics&special=".$Team}
					});

	} else {
		#teile member mit, das er dem team zugefgt wurde
		my $Send = SendMessage(
					{	Email=>0, Intern=>1, 
						System=>1, 
						To=>[$User], From=>0, 
						ToEmail=>"", FromEmail=>"", 
						DeleteAfterXDays=>$LSC{Messages}{DeleteInfo}, 
						Subject=>$LSC{TEXT}{Email}[11], 
						Message=>"", 
						Template=>$LSC{TEXT}{Email}[15], 
						TemplateValues=>{LEADER=>$LSC{username}, TEAM=>$Teamname,
								TEAMLINK=>$LSC{ScriptURL}."$LSC{user_pl}?Action=TeamStatistics&special=".$Team}
					});
	}

}
sub UserAusTeamAlsMemberLoeschen {
	my ($User, $Team) = @_;
	my $do = "delete from lsc_teams_members where Team=? and Member=?";
	my $sth = $LSC{MySQL}->prepare($do);
	$sth->execute($Team, $User);
	$sth->finish;

	my ($Teamname, undef) = TeamnameAndUserFromTeamID($Team);
	if ($User eq $LSC{userid}) {
		#teile leader mit, das member das team verlassen hat
		my @user = LeaderEinesTeams($Team);
		my $Send = SendMessage(
					{	Email=>0, Intern=>1, 
						System=>1, 
						To=>[@user], From=>0, 
						ToEmail=>"", FromEmail=>"", 
						DeleteAfterXDays=>$LSC{Messages}{DeleteInfo}, 
						Subject=>$LSC{TEXT}{Email}[11], 
						Message=>"", 
						Template=>$LSC{TEXT}{Email}[12], 
						TemplateValues=>{MEMBER=>$LSC{username}, TEAM=>$Teamname,
								TEAMLINK=>$LSC{ScriptURL}."$LSC{user_pl}?Action=TeamStatistics&special=".$Team}
					});

	} else {
		#teile member mit, das er gelscht wurde
		my $Send = SendMessage(
					{	Email=>0, Intern=>1, 
						System=>1, 
						To=>[$User], From=>0, 
						ToEmail=>"", FromEmail=>"", 
						DeleteAfterXDays=>$LSC{Messages}{DeleteInfo}, 
						Subject=>$LSC{TEXT}{Email}[11], 
						Message=>"", 
						Template=>$LSC{TEXT}{Email}[13], 
						TemplateValues=>{LEADER=>$LSC{username}, TEAM=>$Teamname,
								TEAMLINK=>$LSC{ScriptURL}."$LSC{user_pl}?Action=TeamStatistics&special=".$Team}
					});
	}
}

sub UserProfile {
	my $user = UserDatenFromUserID($LSC{userid});
	unless ($user) {
		print $LSC{TEXT}{Error}[0].br;
		return;
	}
	if ($q->param('New Password')) {
		if (SessionPasswordCorrect($LSC{username}, $q->param('altespasswort')) eq '1') {
			if ($q->param('neuespasswort') eq $q->param('neuespasswort2')) {
				my $newpass = crypt($q->param('neuespasswort'), $LSC{cryptpass});
				my $do = "update lsc_user set Password='$newpass' where UserID='$LSC{userid}'";
				my $sth = $LSC{MySQL}->prepare($do);
				$sth->execute();
				$sth->finish;
				print $LSC{TEXT}{User}[15].br;
				return;
			} else {
				print $LSC{TEXT}{User}[16].br;
			}
		} else {
			print $LSC{TEXT}{User}[17].br;
		}
	}
	if ($q->param('save')) {
		my $ok = 1;
		if ($q->param('Email')=~/[^a-zA-Z0-9\@\.\-_]/) {
			$ok = 0;
			print $LSC{TEXT}{User}[14].br;
		}
		unless ($q->param('Email')) {
			$ok = 0;
			print $LSC{TEXT}{User}[13].br;
		}
		if ($q->param('ICQ')=~/[^0-9]/) {
			$ok = 0;
			print $LSC{TEXT}{User}[12].br;
		}	
		if ($q->param('Login') eq "") {
			$ok = 0;
			print $LSC{TEXT}{User}[11].br;
		}	
		if ($q->param('GTag')=~/[^0-9]/ || $q->param('GMonat')=~/[^0-9]/ || $q->param('GJahr')=~/[^0-9]/) {
			$ok = 0;
			print $LSC{TEXT}{User}[10].br;
		}
		$ok = UsernameOK($q->param('Login'), $LSC{userid});
		if ($ok) {	
			Require("LSCuser.modif.pm");
			UserDatenSpeichern($LSC{userid}, { Email =>$q->param('Email'), Login =>$q->param('Login'),
					ICQ =>$q->param('ICQ'),
					WonID =>$q->param('WonID'),WonIDText =>$q->param('WonIDText'),
					Birthday=>[$q->param('GTag'),$q->param('GMonat'),$q->param('GJahr')]
				});
			print "Daten wurden gespeichert";
		}
	}
	$q->delete('WonIDText');
	print "<table width=100%>
		<tr>
			<td class=Headline width=100%>
			$LSC{TEXT}{User}[5] $user->{Firstname} $user->{Lastname}
			</td>
			<td class=Standard>".UserLink('=> UEBERSICHT <=', $LSC{userid})."</td>
			
		</tr>
		".start_form('post',"$LSC{user_pl}?League=".$LSC{League}."&Action=Profile")."
		<tr>
			<td class=Standard>$LSC{TEXT}{User}[7]</td>
			<td class=Standard>".$q->textfield('Login', $user->{Login}, 30)."</td>
		</tr>
		<tr>
			<td class=Standard>$LSC{TEXT}{User}[6]</td>
			<td class=Standard>".$q->textfield('Email', $user->{Email}, 30)."</td>
		</tr>
		<tr>
			<td class=Standard>ICQ: </td>
			<td class=Standard>".$q->textfield('ICQ', $user->{ICQ}, 30)."</td>
		</tr>
		<tr>
			<td><br><br></td>
		</tr>

		<tr>
			<td class=Headline>Optional: (jeweilige Liga Regeln beachten!)</td>
		</tr>
		<tr>
			<td class=Standard>$LSC{TEXT}{default}[3]: </td>
			<td class=Standard>".$q->textfield('WonID', $user->{WonID}, 30)."</td>
		</tr>
		<tr>
			<td class=Standard>$LSC{TEXT}{User}[8]: </td>
			<td class=Standard>".$q->textarea('WonIDText',"",3,30)."</td>
		</tr>
		<tr>
			<td class=Standard>$LSC{TEXT}{User}[9]: </td>
			<td class=Standard>".$q->popup_menu(-name=>'GTag', -values=>['',1..31], -default=>$user->{Birthday}).". ".
			$q->popup_menu(-name=>'GMonat', -values=>['',1..12], -default=>$user->{Birthmonth})." ".
			$q->textfield('GJahr', $user->{Birthyear} || '19', 4)."</td>
		</tr>
		<tr>
			<td></td><td class=Standard>".submit('save').end_form."	
			</td>
		</tr>
		<tr>
			<td><br><br></td>
		</tr>
		
		<tr>
			<td class=Headline>
			".start_form('post',"$LSC{user_pl}?League=".$LSC{League}."&Action=Profile")."
			Passwort ndern:
			</td>
		</tr>
		<tr>
			<td class=Standard>Altes Passwort: </td>
			<td class=Standard>".$q->password_field('altespasswort','',10)."</td>
		</tr>
		<tr>
			<td class=Standard>Neues Passwort: </td>
			<td class=Standard>".$q->password_field('neuespasswort','',10)."</td>
		</tr>
		<tr>
			<td class=Standard>Neues Passwort wiederholen: </td>
			<td class=Standard>".$q->password_field('neuespasswort2','',10)."</td>
		</tr>

		<tr>
			<td></td><td class=Standard>".submit('New Password').end_form."	
			</td>
		</tr>
		</table>";
	TeamInfoBearbeiten('', FirstUserTeamID($LSC{userid}), 1);
}

1