
###############################################################################
# Sources From LigaScript                                                     #
###############################################################################
# LigaScript: Online Ligaverwaltung                                           #
#                                                                             #
# Version:        LigaScript Full Version 2.0.1 BETA!                         #
# First-Released: August 1999                                                 #
# Distributed by: http://leagues.ihoax.de                                     #
# =========================================================================== #
# Copyright (c) 2000-2003 Joerg Nass (www.ihoax.de) - All Rights Reserved.    #
# Software by: Joerg Nass                                                     #
# Kontaktinformationen und weiteres sind jeweils auf den angebenen            #
# Homepages zu finden!                                                        #
###############################################################################
#  ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!!                #
#  Bitte den Disclaimer und die Nutzungsbedingungen in der Datei              #
#  LSCConfig.pm lesen!                                                        #
#                                                                             #
###############################################################################




#user funktionen





sub UserKontaktDatenFromUserID {
	unless ($_[0]) {
		return;
	}
	my $sth1;

	if ($LSC{sth}{UserKontaktDatenFromUserID}) {
		$sth1 = $LSC{sth}{UserKontaktDatenFromUserID};
	} else {
		$LSC{sth}{UserKontaktDatenFromUserID} = $LSC{MySQL}->prepare("SELECT Login, Firstname, Lastname, Email, ICQ, truncate((to_days(now())-to_days(birthday))/365, 0) as Age, WonID, DAYOFMONTH(Birthday) as Birthday, MONTH(Birthday) as Birthmonth, YEAR(Birthday) as Birthyear from lsc_user where UserID=?");
		$sth1 = $LSC{sth}{UserKontaktDatenFromUserID};
	}
	
	$sth1->execute($_[0]);
	my $ref = $sth1->fetchrow_hashref();
	$sth1->finish;
	unless ($ref) {
		return;
	}
	return $ref;
}
sub UserDatenFromUserID {
	unless ($_[0]) {
		return;
	}
	my $user = UserKontaktDatenFromUserID($_[0]);
	unless ($user) {
		return;
	}
	
	#weitere daten laden
	my (@ref);
	
	my $sth2;

	if ($LSC{sth}{UserDatenFromUserID2}) {
		$sth2 = $LSC{sth}{UserDatenFromUserID2};
	} else {
		$LSC{sth}{UserDatenFromUserID2} = $LSC{MySQL}->prepare("SELECT Text, DATE_FORMAT(Timestamp,'%e. %M (%T)') from lsc_user_wonid_log where UserID=? order by Timestamp desc limit 2");
		$sth2 = $LSC{sth}{UserDatenFromUserID2};
	}
	
	$user->{WonIDText} = '';
	$sth2->execute($_[0]);
	while (my @ref = $sth2->fetchrow_array()) {
		$user->{WonIDText} .= "$ref[1]: ".$ref[0].br;
	}
	$sth2->finish;

	return $user;
}
sub UserAdminTeam {
	my $League = shift;
	my $User = shift;
	unless ($League && $User) {
		return (0,'');
	}

	my ($select,$from,$where,$group,$order);

	$select	= "T.ID, T.Name";
	$from	= "lsc_teams T, lsc_teams_members M, lsc_teams_league L";
	$where	= "L.League=$League and T.ID=L.Team and T.ID=M.Team and M.Member=$User and M.Status=2";
	$group	= "";
	$order	= "limit 1";
	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");
	$sth->execute();
	my @ref = $sth->fetchrow_array();
	$sth->finish;
	return @ref;
}
sub TeamLigaStatus {
	my $Team = shift || return 1;
	my $League = shift || return 0;

	my $sth1;
	if ($LSC{sth}{TeamLigaStatus}) {
		$sth1 = $LSC{sth}{TeamLigaStatus};
	} else {
		$LSC{sth}{TeamLigaStatus} = $LSC{MySQL}->prepare("select Status from lsc_teams_league where Team=? and League=?");
		$sth1 = $LSC{sth}{TeamLigaStatus};
	}
	
	$sth1->execute($Team, $League);
	my @ref = $sth1->fetchrow_array();
	$sth1->finish;
	return (defined $ref[0]) ? $ref[0] : -1;
}

sub TeamsEinesUsers{
		my $user = shift;
		$user = $LSC{MySQL}->quote($user);

		my $do = "Select ID, Name from lsc_teams where User=$user";
		my $sth = $LSC{MySQL}->prepare($do);
		$sth->execute();
		my %namen;
		while (my @ref = $sth->fetchrow_array()) {
			$namen{$ref[0]} = \@ref;
		}
		$sth->finish;
		
		$do = "Select t.ID, t.Name from lsc_teams t, lsc_teams_members m where m.Member=$user and
		m.status=2 and m.Team=t.ID";
		$sth = $LSC{MySQL}->prepare($do);
		$sth->execute();
		while (my @ref = $sth->fetchrow_array()) {
			unless ($namen{$ref[0]}) {
				$ref[1].=' -> (Leader)';
				$namen{$ref[0]} = \@ref;
			}
		}
		my @namen;
		foreach (keys %namen) {
			push(@namen, $namen{$_});
		}
		return \@namen;
}	
sub ChiefsUndLeaderEinesTeams {
	my $team = shift || return;

	my %user = ();
	my $do = "Select Member from lsc_teams_members M where Team=$team and (Status=1 or Status=2)";
	my $sth = $LSC{MySQL}->prepare($do);
	$sth->execute();
	while (my $ref = $sth->fetchrow_arrayref()) {
		$user{$ref->[0]} = 1;
	}
	$sth->finish;

	#owner dazu zhlen
	$sth = $LSC{MySQL}->prepare("Select User from lsc_teams where ID=$team");
	$sth->execute() or return ();
	while(my $ref = $sth->fetchrow_arrayref()) {
		$user{$ref->[0]} = 1;
	}
	$sth->finish;
	return keys %user;


}
sub TeamStatus {
	my $team =shift;
	if ($team=~/[^0-9]/ || !$team) {
		return 1;
	}
	
	my $sth = $LSC{MySQL}->prepare("SELECT Status FROM lsc_teams WHERE ID=".$LSC{MySQL}->quote($team));
	$sth->execute();
	my $ref = $sth->fetchrow_arrayref();
	$sth->finish;
	return $ref->[0] || 0;
}
sub TeamDatenLaden {
	my $team =shift || return 1;
	if ($team=~/[^0-9]/) {
		return 1;
	}
	
	my $sth = $LSC{MySQL}->prepare("SELECT * FROM lsc_teams WHERE ID=$team");
	$sth->execute();
	my $ref = $sth->fetchrow_hashref();
	$sth->finish;
	return $ref || '';
}

sub LeaderEinesTeams {
	my $team = shift || return;

	my @user = ();
	my $do = "Select Member from lsc_teams_members M where Team=$team and Status=1";
	my $sth = $LSC{MySQL}->prepare($do);
	$sth->execute();
	while (my $ref = $sth->fetchrow_arrayref()) {
		push(@user, $ref->[0]);
	}
	$sth->finish;

	#owner dazu zhlen
	$sth = $LSC{MySQL}->prepare("Select User from lsc_teams where ID=$team");
	$sth->execute() or return ();
	while(my $ref = $sth->fetchrow_arrayref()) {
		push(@user, $ref->[0]);
	}
	$sth->finish;
	return @user;


}
sub ChiefFuerEinTeamInLiga {
	my $user = shift;
	unless ($user) {
		return;
	}
	
	my $league = shift || $LSC{League} || return;
	
	my $do = "Select T.Team from lsc_teams_league T, lsc_teams_members M where T.League=$league and T.Team=M.Team and M.Member=? and M.Status=1";
	my $sth = $LSC{MySQL}->prepare($do);
	$sth->execute($user);
	my @ref = $sth->fetchrow_array();
	$sth->finish;
	return $ref[0];
}
sub LeaderFuerEinTeamInLiga {
	my $user = shift;
	unless ($user) {
		return;
	}
	
	my $league = shift || $LSC{League} || 0;
	
	my $do = "Select T.Team from lsc_teams_league T, lsc_teams_members M where T.League=? and T.Team=M.Team and M.Member=$user
	and M.Status=2";
	my $sth = $LSC{MySQL}->prepare($do);
	$sth->execute($league);
	my @ref = $sth->fetchrow_array();
	$sth->finish;
	return $ref[0];
}
sub IstLeaderVonTeam {
	my $user = shift || return;
	my $team = shift || return;
	
	
	my $do = "Select count(*) from lsc_teams_members where Team=$team and Member=$user and Status=2";
	my $sth = $LSC{MySQL}->prepare($do);
	$sth->execute();
	my @ref = $sth->fetchrow_array();
	$sth->finish;

	$sth = $LSC{MySQL}->prepare("Select Count(*) from lsc_teams where ID=$team and User=$user");
	$sth->execute();
	my @ref2 = $sth->fetchrow_array();
	$sth->finish;

	return ($ref[0] && $ref[0]>0) || ($ref2[0] && $ref2[0]>0);
}
sub TeamsInDenenUserLeaderIst {
	my $user = shift;
	unless ($user) {
		return;
	}
	
	my $do = "Select M.Team from lsc_teams_members M where M.Member=$user and M.Status=2";
	my $sth = $LSC{MySQL}->prepare($do);
	$sth->execute();
	my @teams = ();
	while(my @ref = $sth->fetchrow_array()) {
		push(@teams, $ref[0]);
	}
	$sth->finish;
	return @teams;
}
sub TeamsInDenenUserLeaderOderChiefIst {
	my $user = shift;
	unless ($user) {
		return;
	}
	
	my $do = "Select M.Team from lsc_teams_members M where M.Member=$user and (M.Status=1 or M.Status=2)";
	my $sth = $LSC{MySQL}->prepare($do);
	$sth->execute();
	my %teams = ();
	while(my @ref = $sth->fetchrow_array()) {
		$teams{$ref[0]} = 1;
	}
	$sth->finish;

	#owner dazu zhlen
	$sth = $LSC{MySQL}->prepare("Select ID from lsc_teams where User=$user");
	$sth->execute();
	while(my @ref = $sth->fetchrow_array()) {
		$teams{$ref[0]} = 1;
	}
	$sth->finish;
	return %teams;
}
sub LigenInDenenUserTeamRechteHat {
	my $user = shift || return undef;	
	my $ligaoffen = shift || 0;
	my %Teams = TeamsInDenenUserLeaderOderChiefIst($user);
	unless (%Teams) {
		return undef;
	}

	my $teams = join (", ", keys %Teams);
	
	my $sth = $LSC{MySQL}->prepare("select League from lsc_teams_league where Team in ($teams)");
	$sth->execute();
	my %Leagues = ();
	while(my @ref = $sth->fetchrow_array()) {
		$Leagues{$ref[0]} = 1;
	}
	$sth->finish;

	if ($ligaoffen) {
		my %offen = OffeneLigen();
		foreach (keys %Leagues) {
			if ($offen{$_}) {
				$Leagues{$_} = $offen{$_};
			} else {
				delete $Leagues{$_};
			}

		}
	}
	return %Leagues;



}

########### Test / Admin - Funktionen
sub UserAktiv {
	my $User = shift;
	return;
	unless ($User) {return;}

	my $select	= "select count(*) from lsc_games where User=$User";
	my $sth = $LSC{MySQL}->prepare("$select");
	$sth->execute();
	my $r = $sth->fetchrow_arrayref();
	$sth->finish;

	if ($r && $r->[0]>0) {
		return $r->[0];
	} 
	return;
}

sub TeamAktiv {
	my $Team = shift;
	unless ($Team) {return;}
	$Team = $LSC{MySQL}->quote($Team);

	my $select	= "select count(*) from lsc_games where Team=$Team";
#	print $select.br;
	my $sth = $LSC{MySQL}->prepare("$select");
	$sth->execute();
	my $r = $sth->fetchrow_arrayref();
	$sth->finish;

	if ($r && $r->[0]>0) {
		return $r->[0];
	} 
	return;
}


sub UserMenu {
	print "<div class=Headline>$LSC{TEXT}{default}[1] $LSC{username}</div>".br;
	print "$LSC{TEXT}{User}[0]".br.br;
	print "<table>";

	print '<tr><td  style="BACKGROUND-COLOR: #E2E2E2">';
		print ShowLink({Name => "Profil", Script => "$LSC{user_pl}", Action => "Profile", Class=>"UserMenu"}, 1);
	print '</td><td  style="BACKGROUND-COLOR: #E2E2E2">';
		print "$LSC{TEXT}{User}[1]";
	print "</td></tr>";
	print '<tr><td  style="BACKGROUND-COLOR: #E2E2E2">';
		print ShowLink({Name => "SupportTickets", Script => "$LSC{user_pl}", Action => "SupportTicketAll", Class=>"UserMenu"}, 1);
	print '</td><td  style="BACKGROUND-COLOR: #E2E2E2">';
		print "$LSC{TEXT}{User}[32]";
	print "</td></tr>";

	if ($LSC{Forderungen}{S}) {
		print '<tr><td  style="BACKGROUND-COLOR: #E2E2E2">';
			print ShowLink({Name => "$LSC{TEXT}{Messages}[0] ", Script => "$LSC{user_pl}", Action => "NewGame", Class=>"UserMenu"}, 1);
		print '</td><td  style="BACKGROUND-COLOR: #E2E2E2">';
			print "$LSC{TEXT}{User}[2]";
		print "</td></tr>";
	}

	print '<tr><td  style="BACKGROUND-COLOR: #E2E2E2">';
		print ShowLink({Name => "$LSC{TEXT}{Teamname2} Profil", Script => "$LSC{user_pl}", Action => "TeamInfo", Class=>"UserMenu"}, 1);
	print '</td><td  style="BACKGROUND-COLOR: #E2E2E2">';
		print "$LSC{TEXT}{User}[3]";
	print "</td></tr>";

	print '<tr><td  style="BACKGROUND-COLOR: #E2E2E2">';
		print ShowLink({Name => "$LSC{TEXT}{Teamname2} $LSC{TEXT}{default}[2]", Script => "$LSC{user_pl}", Action => "NewTeam", Class=>"UserMenu"}, 1);
	print '</td><td  style="BACKGROUND-COLOR: #E2E2E2">';
		print "$LSC{TEXT}{User}[4]";
	print "</td></tr>";
	print "</table>";

}
sub TeamnameOK {
	my $Team = shift || return undef;
	my $TeamID = shift || 0;
	my $ok = 1;
		if (!($Team=~/[^0-9]/ && $Team=~/\w/)) {
			$ok = 0;
			print "Der Teamname darf nicht nur auszahlen bestehen. ($Team)".br;
		}
		if ($Team=~/[^\w \[\]_\-\.\|\=]/ ) {
			$ok = 0;
			print "Der Teamname darf nur Buchstaben und folgende Zeichen enthalten: \"[]_-.|=\"".br;
		}
		my $ID = TeamIDFromName($Team);
		if ($ok && ($ID && $ID != $TeamID)) {
			$ok = 0;
			print "Dieser Teamname ist bereits vergeben.".br;
			if ($LSC{Admin}) {
				$ok=1;
			}
		}				
	return $ok
}
sub UsernameOK {
	my $User = shift || return undef;
	my $UserID = shift || 0;
	my $ok = 1;
		if (!($User=~/[^0-9]/ && $User=~/\w/)) {
			$ok = 0;
			print "Der Loginname darf nicht nur auszahlen bestehen.".br;
		}
		if ($User=~/[^\w \[\]_\-\.]/ ) {
			$ok = 0;
			print "Der Loginname darf nur Buchstaben und folgende Zeichen enthalten: \"[, ], _, -, .\".".br;
		}
		my $id = UserIDFromName($User);
		if ($id && $id != $UserID) {
			$ok = 0;
			print "Dieser Loginname ist bereits vergeben, bitte whle einen anderen.".br;
		}
	return $ok
}
sub	UserVonEmailAdresse {
	my $sth = $LSC{MySQL}->prepare("select UserID from lsc_user where Email=?");
	$sth->execute($_[0] || "-1") || return 0;
	my $r = $sth->fetchrow_arrayref();
	$sth->finish;

	if ($r && $r->[0]) {
		return $r->[0];
	}
	return 0;

}
sub UserInfo {
	my $Info = "";
	unless ($LSC{userid}) {
		return "";
	}
	if ($LSC{Messages}{S} && (my $anzahl = MessageToolsNewMSGforUser($LSC{userid}))) {
		my $Link;
		$Link->{Name} = "\[$LSC{TEXT}{default}[0]\]"; #anzeigen
		$Link->{League} = $LSC{League};
		$Link->{Action} = "MSG";
		$Link->{Action2} = "Inbox";
		$Link->{Script} = "$LSC{user_pl}";

		$Info .= $LSC{TEXT}{Messages}[3]." ".ShowLink($Link, 1).br if $anzahl == 1;
		$Info .= $anzahl." ".$LSC{TEXT}{Messages}[4]." ".ShowLink($Link, 1).br if $anzahl > 1;
	}
	if ($LSC{SupportTicketFunktion}) {
		#offene supporttickets anzeigen
		my %Teams = TeamsInDenenUserLeaderOderChiefIst($LSC{userid});
		my $Teams = join (",", keys %Teams) || -1;

		# Alle Tickets anzeigen:
		my $sth = $LSC{MySQL}->prepare("select count(*) from lsc_supportticket where SupportID=0 and Status=0 and (? in (UserID,UserID1,UserID2,UserID3) or TeamID1 in ($Teams) or TeamID2 in ($Teams) or TeamID3 in ($Teams))");
		my $usertickets = 0;
		if ($sth->execute($LSC{userid})) {	
			my $c = $sth->fetchrow_arrayref();
			if ($c && $c->[0]) {
				$usertickets = $c->[0];
			}
			$sth->finish();
		}	
		if ($usertickets) {
			$Info .= 'Member: '.ShowLink({Name => $usertickets." SupportTicket(s)", Script => "$LSC{user_pl}", Action => "SupportTicketAll", Class=>""}, 1).br;
		}
		my @adminleagues = LigenInDenenUserAdminIst($LSC{userid});
		if (scalar @adminleagues || $LSC{UserStatus}==9) {
			# Alle Admin Tickets anzeigen:
			my $leagues = scalar @adminleagues ? join (",", @adminleagues) : "-1";

#	my $sth = $LSC{MySQL}->prepare("select id, League, UserID, AdminID, Subject, WaitingID, GameID, Status, Date  from lsc_supportticket where League=? and SupportID=0 order by Status, id");
#	my $sth2 = $LSC{MySQL}->prepare("select count(*) from lsc_supportticket where League=? and SupportID=? Group by SupportID");
			my $sth3 = $LSC{MySQL}->prepare("select UserID from lsc_supportticket where League=? and SupportID=? order by id desc limit 1");

			
			my $sth = $LSC{MySQL}->prepare("select 1, League, id, AdminID from lsc_supportticket where SupportID=0 and Status=0 and (League in ($leagues) or ".($LSC{UserStatus} && $LSC{UserStatus}==9 ? 1 : 0).") order by League");
			my $admintickets = "";
			my $lastleague = 0;
			my $lastleaguecount = 0;
			my $totalcounter = 0;
			my %AdminTickets = ();
			if ($sth->execute()) {	
				while (my $c = $sth->fetchrow_arrayref()) {
					if ($c && $c->[0]) {
						if ($sth3->execute($c->[1], $c->[2])) {	
							my $lastpostuserid = $sth3->fetchrow_arrayref();

							# andere liga
							if ($lastleague != $c->[1]) {
								# ausgeben
								$admintickets .= ShowLink({Name => '['.($lastleague || 'global').'('.$lastleaguecount.')]', Script => "admin.pl",	 Action => "SupportTicket", Class=>"", League => $lastleague}) if $lastleaguecount > 0;
								$AdminTickets{$lastleague} = $lastleaguecount if $lastleaguecount > 0;
								$lastleaguecount = 0;
							}
							
							# anderer als admin gepostet oder kein admin
							if ($lastpostuserid->[0] != $c->[3] || $c->[3] == 0) {
								$lastleague = $c->[1];
								$lastleaguecount++;
								$totalcounter++;
							}
						}
					}
				}
				$sth->finish();
				$admintickets .= ShowLink({Name => '['.($lastleague || 'global').'('.$lastleaguecount.')]', Script => "admin.pl",	 Action => "SupportTicket", Class=>"", League => $lastleague}) if $lastleaguecount > 0;
				$AdminTickets{$lastleague} = $lastleaguecount if $lastleaguecount > 0;
			}	
			if ($admintickets) {
				#$Info .= 'Admin-Supporttickets: '.$admintickets;

				$Info .= 'New Supporttickets ('.$totalcounter.'): '.
						'<select name="League" onchange="javascript:if( options[selectedIndex].value >= 0) document.location = \'admin.pl?League=\'+options[selectedIndex].value+\'&Action=SupportTicket\'" style="font-size: 10px">';
				$Info .= '<option selected="selected" value="-1">choose</option>';

				foreach (sort keys %AdminTickets) {
					$Info .= '<option value="'.$_.'">'.LigaName($_)." => $AdminTickets{$_}".'</option>';
				}
				$Info .= '</select>';
			}
		}
	}

	if ($Info) {
		my @Layout = split(/\<USER-INFO\>/,	$LSC{UserInfoLayout});
		return ($Layout[0] || "").
				$Info.
				($Layout[1] || "");
	}
	return "";
}


Require("LSCuserfull.pm");

1
