#!/usr/bin/perl -w

###############################################################################
# Sources From LigaScript                                                     #
###############################################################################
# LigaScript: Online Ligaverwaltung                                           #
#                                                                             #
# Version:        LigaScript Full Version 2.0.1 BETA!                         #
# First-Released: August 1999                                                 #
# Distributed by: http://leagues.ihoax.de                                     #
# =========================================================================== #
# Copyright (c) 2000-2003 Joerg Nass (www.ihoax.de) - All Rights Reserved.    #
# Software by: Joerg Nass                                                     #
# Kontaktinformationen und weiteres sind jeweils auf den angebenen            #
# Homepages zu finden!                                                        #
###############################################################################
#  ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!!                #
#  Bitte den Disclaimer und die Nutzungsbedingungen in der Datei              #
#  LSCConfig.pm lesen!                                                        #
#                                                                             #
###############################################################################



use CGI qw(:standard);
use CGI::Carp qw(fatalsToBrowser);
use POSIX;
use strict;

use vars qw(%LSC %ligafunktionen %funktionen %require $LSCPackagePfad $q $scriptname $extern);


require "lsc_pfad.pl";

$CGI::DISABLE_UPLOADS   = 0;
$CGI::POST_MAX          = 1024*10;
$q = new CGI;
$scriptname = script_name();

%ligafunktionen = (
	'LeagueStatistics'			=> \&StatistikenLiga,
	'TeamStatistics'			=> \&StatistikenTeam,
	'LeagueBestOfTable'			=> \&LigaBestOfTable,
	'Opponent'					=> \&StatistikenGegner,
	'Results'					=> \&Results,
	'ShowResult'				=> \&ShowResult,
	'Standings'					=> \&Standings,
	'StandingsB'				=> \&StandingsB,
	'WeekStandings'				=> \&WochenTabelle,
	'Rules'						=> \&ShowRules,
	
	'TeamVergleich'				=> \&TeamVergleich,
	'ErgebnisListeMain'			=> \&ErgebnisListeMain,
	'ErgebnisListeAnzeigen'		=> \&ErgebnisListeAnzeigen,


);

%funktionen = (
	'Members'					=> \&ShowAllMembers,
	'Clans'						=> \&ShowAllClans,
	'TeamStatistics'			=> \&StatistikenTeam,
	'NewsHistorie'				=> \&NewsHistorieShow,
	'Vote'						=> \&VoteShow,
	'User'						=> \&StatistikenUser,
);

%require = (
	'Standings',				'LSCstandings.pm',
	'StandingsB',				'LSCstandings.pm',
	'Results',					'LSCErgebnisse.out.pm',
	'ShowResult',				'LSCErgebnisse.out.pm',
	'LeagueBestOfTable',		'LSCstatistic.out.pm',
	'WeekStandings',			'LSCstatistic.out.pm',


	'TeamStatistics',			'LSCstatistik.pm',
	'LeagueStatistics',			'LSCstatistik.pm',
	'Opponent',					'LSCstatistik.pm',
	'User',						'LSCstatistik.pm',
);

$LSC{Funktionen} = "show";
require $LSCPackagePfad."LSCInit.pm";

if ($LSC{PlayerStats}) {
	$require{'Draft'} = 'LSCPlayerStatsDraft.pm';
	$ligafunktionen{'Draft'} = \&PlayerDraft;
}


&LayoutEins;
if ($q->cgi_error) {
	print $LSC{TEXT}{ERROR}[10].br;
} elsif ($LSC{ligavorhanden} && !$funktionen{$LSC{Action}}) {
	print "<div class=LeagueHeadline>".ShowLink({Name=>"/Home", Script=>$LSC{show_pl}, Class=>"HeadlineLink", League=>""}).ShowLink({Name=>"/".$LSC{LeagueData}{Name}, Script=>"show.pl", Class=>"HeadlineLink", League=>$LSC{League}}).":".($LSC{Spieltag} ? " - Aktueller Spieltag: $LSC{Spieltag} -
		".SpielplanSpieltagBeschreibung($LSC{Spieltag}) : "")."</div>".br.br;

	if ($ligafunktionen{$LSC{Action}}) {
		if ($require{$LSC{Action}}) {
			Require("$require{$LSC{Action}}");
		}
		$ligafunktionen{$LSC{Action}}->($LSC{Action2}, $LSC{special});
	} else {

		my $Values = {	"LSC-League"=>$LSC{League}, 
						"LSC-AnzahlSpiele"=>Liga_AnzahlSpiele($LSC{League}),
						"LSC-AnzahlUser"=>Liga_AnzahlteilnehmenderUser($LSC{League}),
						"LSC-AnzahlUserAktiv"=>Liga_AnzahlAktiverUser($LSC{League}),
						"LSC-Ligastatus"=>$LSC{Status}{$LSC{LeagueData}{Status}}
			
						};
		my $Temp = {};
		$Temp->{Next} = "first";
		my $i = 0;
		while ($Temp->{Next} && $i++ < 10) {
			TemplateShowStep($LSC{Templates}{'LigaUebersicht'}, $Values, $Temp);
			if ($Temp->{Next}) {
				if ($Temp->{Next} eq "LSC-TabelleKlein") {
					Require("LSCstandings.pm");
					Standings('',1);
				} elsif ($Temp->{Next} eq "LSC-ErgebnisseKlein") {
					$LSC{Templates}{'ErgebnisseLiga'} = $LSC{Templates}{'ErgebnisseLigaSmall'};
					Require("LSCErgebnisse.out.pm");
					GamesOverview(1,0,10,"Last Games", 2);
				} elsif ($Temp->{Next} eq "LSC-Spielplan") {
					if($LSC{LeagueData}{Spielplan}) {
						SpielplanAnzeigen();
					}
				} elsif ($Temp->{Next} eq "LSC-LeagueNews") {
					NewsAnzeigen($LSC{League},6);
				} elsif ($Temp->{Next} eq "LSC-LeaguePokal") {
					if ($LSC{LeagueData}{PlayoffDaten}{'PokalBestOf'}) {
						PlayoffPokalErgebnisse();
					}
				} else {
					print "Unbekannter LSC-TAG: &ltLSC-TabelleKlein&gt ne &ltLSC-TabelleKlein&gt".br;
				}
			}
		}


# noch updaten:
#		if ($LSC{Forderungen}{S}) {
#			MSGForderungenVonHeute();
#			MSGForderungenNaechsten();
#		}
	
	}
} elsif ($funktionen{$LSC{Action}}) {
	if ($LSC{ligavorhanden}) {
		print "<div class=LeagueHeadline>".ShowLink({Name=>"/Home", Script=>$LSC{show_pl}, Class=>"HeadlineLink", League=>""}).ShowLink({Name=>"/".$LSC{LeagueData}{Name}, Script=>"show.pl", Class=>"HeadlineLink", League=>$LSC{League}}).":".($LSC{Spieltag} ? " - Aktueller Spieltag: $LSC{Spieltag} -
			".SpielplanSpieltagBeschreibung($LSC{Spieltag}) : "")."</div>".br.br;
	}
	if ($require{$LSC{Action}}) {
			Require($require{$LSC{Action}});
	}
	$funktionen{$LSC{Action}}->($LSC{Action2}, $LSC{special});
} elsif ($LSC{Action}) {
	print "Unbekannte Funktion.";
} else {
	if ($LSC{League} ne '') {
		print "$LSC{TEXT}{ERROR}[2]<br><br>";
	}
	LigenAnzeigen($LSC{Action2}, $LSC{special});
}


MySQLDisconnect($LSC{MySQL});

#my $TimeGesamt = tv_interval($Tgesamt);
#print "Gesamt: $TimeGesamt".br;
#print "Init: $TimeInit".br;
#print "Func: ".tv_interval($Tfunc).br;
&LayoutZwei;

exit(0);
sub ShowRules {
	my $values = {};

	$values->{"LSC-LeagueAdmins"} = "";
	if ((my @admins = AdminsForThisLeague())) {
		foreach my $a (@admins) {
			my $user = UserKontaktDatenFromUserID($a);
			$values->{"LSC-LeagueAdmins"} .= UserLink($user->{Login}, $a).MessageLink({To=>$user->{Login}})." ICQ: $user->{ICQ}".($user->{ICQ} ? AddICQOnlineStatus($user->{ICQ}) : "").br;
		}
	}
	$values->{"LSC-GlobalAdmins"} = $LSC{AdminKontakt};
	$values->{"LSC-LeagueMemberJoin"} = $LSC{OpenL}{$LSC{LeagueData}{MJoin}};
	$values->{"LSC-LeagueStatus"} = $LSC{Status}{$LSC{LeagueData}{Status}};

	$values->{"LSC-Forderungen"} = $LSC{LeagueData}{Forderungen} ? ($LSC{LeagueData}{Forderungen} == 1 ? "ja" : "zwingend") : "nein";
	$values->{"LSC-F_Max"} = "-";
	$values->{"LSC-F_Rank_Min"} = "-";
	$values->{"LSC-F_Rank_Max"} = "-";
	$values->{"LSC-F_Points_Min"} = "-";
	$values->{"LSC-F_Points_Max"} = "-";
	$values->{"LSC-Forderungen_Change_Min"} = "-";
	$values->{"LSC-Forderungen_Change_Max"} = "-";
	$values->{"LSC-Forderungen_ReMoveHours"} = "-";
	$values->{"LSC-Forderungen_Zeitraum"} = "-";
	
	if ($LSC{LeagueData}{Forderungen}) {
		$values->{"LSC-F_Max"} = $LSC{LeagueData}{F_Max} || "?";
		$values->{"LSC-F_Rank_Min"} = $LSC{LeagueData}{F_Rank_Min} || "?";
		$values->{"LSC-F_Rank_Max"} = $LSC{LeagueData}{F_Rank_Max} || "?";
		$values->{"LSC-F_Points_Min"} = $LSC{LeagueData}{F_Points_Min} || "?";
		$values->{"LSC-F_Points_Max"} = $LSC{LeagueData}{F_Points_Max} || "?";
		$values->{"LSC-Forderungen_Change_Min"} = $LSC{LeagueData}{Forderungen_Change_Min} || "?";
		$values->{"LSC-Forderungen_Change_Max"} = $LSC{LeagueData}{Forderungen_Change_Max} || "?";
		$values->{"LSC-Forderungen_ReMoveHours"} = $LSC{LeagueData}{Forderungen_ReMoveHours} || "?";
		$values->{"LSC-Forderungen_Zeitraum"} = $LSC{LeagueData}{Forderungen_Zeitraum};
	}

	$values->{"LSC-Spielplan"} = $LSC{LeagueData}{Spielplan} ? ($LSC{LeagueData}{Spielplan} == 1 ? "ja" : "zwingend") : "nein";
	$values->{"LSC-Waitlist"} = $LSC{LeagueData}{WaitlistID} ? "ja" : "nein";
	
	$values->{"LSC-AnzahlMaps"} = $LSC{LeagueData}{AnzahlMaps};
	$values->{"LSC-MapName"} = $LSC{LeagueData}{MapName} ? RemoveHtmlFromText($LSC{LeagueData}{MapName}) : "?";
	$values->{"LSC-Mapliste"} = "nein";
	if ($LSC{LeagueData}{Mapliste}) {
		my %maps = MapListe();
		my @maps = ();
		foreach (keys %maps) {
			push @maps, $maps{$_};
		}
		$values->{"LSC-Mapliste"} = join(", ", @maps);
	}
	$values->{"LSC-Playoff"} = $LSC{LeagueData}{Playoff} ? $LSC{TEXT}{Playoff}[1][$LSC{LeagueData}{Playoff}] : "-";
	$values->{"LSC-Waitlist"} = $LSC{LeagueData}{WaitlistID} ? ShowLink({Name=>"ja", Script=>"$LSC{user_pl}", Action=>"ShowWaitlist", League=>$LSC{League}}) : "nein";
	
	$values->{"LSC-Support"} = "-";
	if ($LSC{SupportTicketFunktion}) {
		$values->{"LSC-Support"} = ShowLink({Name=>'Supportticket', Script=>"$LSC{user_pl}", Action=>"NewSupport", Action2=>"", Special=>"", League=>$LSC{League}}); #protest
	}

	print TemplateShow($LSC{Templates}{'Rules'}, $values);

	if ($LSC{Admin} && $q->param('speichern')) {
		my $do	= "replace into lsc_leagues_rules (League, Text) Values (".
				$LSC{League}.", ".
				$LSC{MySQL}->quote($q->param("Rules")).")";
		my $sth = $LSC{MySQL}->do("$do");
		print "Regeln wurden gespeichert!".br;	
	}
	
	my ($select,$from,$where,$group,$order);
		$select	= "Text";
		$from	= "lsc_leagues_rules";
		$where	= "League=$LSC{League}";
	
	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where");
	$sth->execute();
	my $ref = $sth->fetchrow_arrayref();
	$sth->finish;
	
	if ($ref && $ref->[0]) {
		print "<table width=100%>
			<tr>
				<td class=Headline>Weitere Regeln und Informationen zur Liga
				</td>
			</tr>
			<tr>
				<td>".RemoveHtmlFromText($ref->[0])."
				</td>
			</tr>
		</table>";
		
		print br.br.br.hr.$LSC{TEXT}{ERROR}[8] if $LSC{TEXT}{ERROR}[8];
	
	} else {
		# erstmal nichts ausgeben
		#print "Es wurden noch keine Regeln festgelegt";
	}
	#########
	########### Join
	########


			if ($LSC{LOGIN} && $LSC{LeagueData}{Status} == 1 && !$LSC{userteamid} && $LSC{LeagueData}{MJoin} == 0) {
				print "<div class=Headline>$LSC{TEXT}{show}[5]</div>";
				my $save="$LSC{user_pl}?League=$LSC{League}&Action=JoinLeague";
				print    $q->start_form('post',$save);
				print $LSC{TEXT}{show}[14].br;
				print $q->submit($LSC{TEXT}{JoinLeague}),end_form;
			} elsif ($LSC{LOGIN} && $LSC{LeagueData}{Status} == 1 && !$LSC{userteamid} && $LSC{LeagueData}{MJoin} == 2) {
				print "<div class=Headline>$LSC{TEXT}{show}[5]</div>";
				my ($anzahl, $teams) = AnzahlTeamsUndNamenID($LSC{userid});
				if ($anzahl > 1) {
					my %Teams;
					foreach my $t (@{$teams}) {
						unless ($t->[1]=~/\*/) {
							$Teams{$t->[0]} = $t->[1];
						}
					}
					my $save="$LSC{user_pl}?League=$LSC{League}&Action=JoinLeagueTeam";
				
					print    $q->start_form('post',$save);
					print $LSC{TEXT}{show}[14].br;
					print $q->submit($LSC{TEXT}{JoinLeagueTeam}),
						$q->popup_menu(-name=>'Team',-values=>[keys %Teams],-labels=>\%Teams), $q->end_form();
				} else {
					print $LSC{TEXT}{TeamErstellen};
				}
			} elsif ($LSC{LOGIN} && 
					$LSC{LeagueData}{Status} == 1 && 
					!$LSC{userteamid} && 
					$LSC{LeagueData}{MJoin} == 1 &&
					$LSC{LeagueData}{WaitlistID}
					) {
					print br.$LSC{TEXT}{show}[8].br;
					my ($anzahl, $teams) = AnzahlTeamsUndNamenID($LSC{userid});
					if ($anzahl > 0) {
						my $aufwarteliste = 0;
						my %Teams;
						foreach my $t (@{$teams}) {
								$Teams{$t->[0]} = $t->[1];
								$aufwarteliste = 1 if AufWarteLIste($t->[0] || 0, $LSC{LeagueData}{WaitlistID});
						}

						my $save="$LSC{user_pl}?League=$LSC{League}&Action=JoinLeagueWaitlist";
						if ($aufwarteliste) {
							print $LSC{TEXT}{show}[11].br.br;

							print $LSC{TEXT}{show}[12];
							print    $q->start_form('post',$save);
							print $q->submit("delete").br;
						} else {
							print    $q->start_form('post',$save);
							print $q->submit($LSC{TEXT}{JoinLeagueTeam}),
								$q->popup_menu(-name=>'Team',-values=>[keys %Teams],-labels=>\%Teams), $q->end_form();
							print $LSC{TEXT}{show}[9].br;
						}
					} else {
						print $LSC{TEXT}{ERROR}[6].br; #keine team id gefunden
					}
					print br.br;
			}
	


	########
	########### /Join
	########

	if ($LSC{Admin}) {
		print br.br.br.hr;
		print "Adminbereich: Hier kannst du den Text fr die Regeln einfgen oder ndern.".br;
		print "Achtung! Aus Sicherheitsgrnden ist es nicht mehr mglich hier HTML Code einzufgen!".br.br;

		print start_form('post',"$scriptname?League=$LSC{League}&Action=Rules");
		print $q->textarea('Rules',$ref ? $ref->[0] : "",10,40);
		print br;
		print submit('speichern'),end_form;
		print '[quote] Zitat [quote]<br>[email]<A HREF="email@blabla.xyz">email@blabla.xyz</A>[/email]<br>[b]<b>fett</b>[/b]<br>[u]<u>unterstrichen</u>[/u]<br>[i]<i>kursiv</i>[/i]';
	}
	


}

