#!/usr/bin/perl -w


###############################################################################
# Sources From LigaScript                                                     #
###############################################################################
# LigaScript: Online Ligaverwaltung                                           #
#                                                                             #
# Version:        LigaScript Full Version 2.0.1 BETA!                         #
# First-Released: August 1999                                                 #
# Distributed by: http://leagues.ihoax.de                                     #
# =========================================================================== #
# Copyright (c) 2000-2003 Joerg Nass (www.ihoax.de) - All Rights Reserved.    #
# Software by: Joerg Nass                                                     #
# Kontaktinformationen und weiteres sind jeweils auf den angebenen            #
# Homepages zu finden!                                                        #
###############################################################################
#  ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!!                #
#  Bitte den Disclaimer und die Nutzungsbedingungen in der Datei              #
#  LSCConfig.pm lesen!                                                        #
#                                                                             #
###############################################################################



use CGI qw(:standard);
use CGI::Carp qw(fatalsToBrowser);
use strict;
use vars qw(%LSC %ligafunktionen %funktionen %require $LSCPackagePfad $q $scriptname);

require "lsc_pfad.pl";

$CGI::DISABLE_UPLOADS   = 1;
$CGI::POST_MAX          = 1024*10;
$q = new CGI;
$scriptname = script_name();

my %Userfunktionen = (
	'UnlockGames', 1
	
);
%funktionen = ( 
	''						=> \&startseite,
	'login'					=> \&startseite,
	
	'NewGame'				=> \&ErgebnisseNeu,
	'NewGameF'				=> \&ErgebnisseNeuForderung,
	'logout'				=> \&startseite,
	'JoinLeague'			=> \&JoinLeague,
	'JoinLeagueTeam',		=> \&JoinLeagueTeam,
	'UserOverview'			=> \&StatistikenUser,
	'Profile'				=> \&UserProfile,
	'NewTeam'				=> \&NeuesZweitTeamErstellen,
	'TeamInfo'				=> \&TeamInfoBearbeiten,
	

	'MSGFordern'			=> \&MSGFordern,
	'TeamFordern'			=> \&TeamFordern,
	'User'					=> \&UserMenu,
	'MSG'					=> \&MessagesShow,
	'Search'				=> \&TeamUserSuchen,
	'Members'				=> \&ShowMembers,
	'Punish'				=> \&StrafpunkteAnzeigen,

	'Vote'					=> \&VotePolls,
	'SupportTicketAll'		=> \&SupportTicketShowUser,	
	'SupportTicket'			=> \&SupportTicketShow,	

	'Switch'				=> \&SwitchUserStatus,
	

);
%require = (
	'UserOverview',			'LSCstatistik.pm',
	'NewTeam',				'LSCuser.create.pm',
	'TeamInfo',				'LSCuser.modif.pm',
	'Profile',				'LSCuser.modif.pm',
	'NewGame',				'LSCErgebnisse2.pm',
	'NewGameF',				'LSCErgebnisse2.pm',
	'Punish',				'LSCStrafpunkte.pm',
	'SupportTicketAll',		'LSCSupportTicket.pm',
	'SupportTicket',		'LSCSupportTicket.pm',
);


# Funktionen, die nur ausgfehrt werden drfen, wenn eine Liga ausgewhlt
# ist

$LSC{Funktionen} = "user";
require $LSCPackagePfad."LSCInit.pm";

if ($LSC{PlayerStats}) {
	$require{'Draft'} = 'LSCPlayerStatsDraft.pm';
	$require{'FreeAgents'} = 'LSCPlayerStatsDraft.pm';
	$funktionen{'Draft'} = \&PlayerDraftUser;
	$funktionen{'FreeAgents'} = \&PlayerDraftFreeAgents;
}
if ($LSC{SupportTicketFunktion}) {
	$funktionen{'SupportW'} = \&SupportNewTicketWait;
	$require{'SupportW'} = 'LSCSupportTicket.pm';

	$funktionen{'NewSupport'} = \&SupportNewTicketGlobal;
	$require{'NewSupport'} = 'LSCSupportTicket.pm';
}

# Main #
if ($q->cgi_error) {
	&LayoutEins;
	print $LSC{TEXT}{ERROR}[10].br;
	&LayoutZwei;
} elsif ($LSC{LOGIN}) {
	HauptMenue();
} elsif ($LSC{Action} eq 'LostPassword') {
	&LayoutEins;
	Session('LostPassword');
	&LayoutZwei;
} else {
	my $Session;
	if (($Session = Session('Login')) eq 1) {
		HauptMenue();
	} else {
		&LayoutEins;
		print $Session;
		&LayoutZwei;
	}
}
MySQLDisconnect($LSC{MySQL}); #in Init initialisiert
exit(0);
# /Main #




sub HauptMenue {
	&LayoutEins;
	if ($LSC{LeagueData}{Name}) {
		print "<div class=LeagueHeadline>".ShowLink({Name=>"/Home", Script=>$LSC{show_pl}, Class=>"HeadlineLink", League=>""}).(ShowLink({Name=>"/".$LSC{LeagueData}{Name}, Script=>"show.pl", Class=>"HeadlineLink", League=>$LSC{League}}) || 'LigaScript').":".($LSC{Spieltag} ? " - Aktueller Spieltag: $LSC{Spieltag} -
		".SpielplanSpieltagBeschreibung($LSC{Spieltag}) : "")."</div>".br.br;
	} 

	if (!$LSC{refererok}) {
		print $LSC{TEXT}{Error}[5].br;
		#print $LSC{AllowedRefererError};
	} elsif ($LSC{LOGIN} && $LSC{Action}) {

			DoUserAction();
	} else {
		UserMenu($LSC{Action2}, $LSC{special});
		print br.br.br;
		Require("LSCstatistik.pm");
		StatistikenUser("", $LSC{userid});
	}

	&LayoutZwei;

	#print $q->redirect("show.pl?League=$LSC{League}"); old
}
sub DoUserAction {
	if ($funktionen{$LSC{Action}}) {
			if ($require{$LSC{Action}}) {
				Require($require{$LSC{Action}});
			}
			$funktionen{$LSC{Action}}->($LSC{Action2}, $LSC{special});
			return 1;
	} 
	print "Diese Funktion ist nicht verfgbar!".br;
	return;
}
sub JoinLeague {
	if ($LSC{LeagueData}{Status} == 1 && !$LSC{userteamid} && $LSC{LeagueData}{MJoin} == 0) {
		my $id= FirstUserTeamID($LSC{userid});
		unless ($id) {
			print "Es ist ein Fehler beim ermitteln deiner TeamID aufgetrehten. Bitte wende Dich an einen
			Admin.".br;
			return;
		}
		my $do = "INSERT INTO lsc_teams_league 
		(Team, League)
		VALUES
		('$id', '$LSC{League}')";
		my $sth = $LSC{MySQL}->prepare($do);
		$sth->execute();
		$sth->finish;
		
		Require("LSCPoints.pm");
		Points_TeamAktualisieren($id);

		print "Du bist nun fr diese Liga freigeschaltet!".br;
		return;
	} 
	
	print "Du konntest nicht freigeschaltet werden. Bitte wende Dich an einen Admin.".br;
}
sub JoinLeagueTeam {
	if ($LSC{LeagueData}{Status} == 1 && !$LSC{userteamid} && $LSC{LeagueData}{MJoin} == 2) {
		my $id= FirstUserTeamID($LSC{userid});
		if (!$q->param('Team') || $q->param('Team') eq $id || $q->param('Team')=~/[^0-9]/) {
			print "Es ist ein Fehler beim ermitteln deiner TeamID aufgetrehten. Bitte wende Dich an einen
			Admin.".br;
			return;
		}
		my $Team = TeamDatenLaden($q->param('Team'));
		unless ($Team) {
			print "Es konnten keine Daten fr dieses Team geladen werden.".br;
			return;
		}
		if ($Team->{User} ne $LSC{userid} and !IstLeaderVonTeam($LSC{userid}, $q->param('Team'))) {
			print $LSC{TEXT}{ERROR}[4].br; #Dieses Team gehrt Dir nicht
			return;
		}
		if ($Team->{PrivateTeam} eq "1") {
			print $LSC{TEXT}{ERROR}[5].br; #privateteam
			return;
		}
		$id = $LSC{MySQL}->quote($q->param('Team'));
		my $do = "INSERT INTO lsc_teams_league 
		(Team, League)
		VALUES
		($id, '$LSC{League}')";
		my $sth = $LSC{MySQL}->prepare($do);
		$sth->execute();
		$sth->finish;
		Require("LSCPoints.pm");
		Points_TeamAktualisieren($id);
		print "Dein Team ist nun fr diese Liga freigeschaltet!".br;
		return;
	} 
	
	print "Du konntest nicht freigeschaltet werden. Bitte wende Dich an einen Admin.".br;
} 


sub TeamUserSuchen {
	my $Action = shift || 0;
	print "<div class=Headline>Suchen</div>".br.br;
	print "<a href=$LSC{user_pl}?League=$LSC{League}&Action=Search>[Neue Suche]</a>".br.br;

	my $TeamID;
	if ((!$Action || $Action eq "Team") && ($TeamID=TeamSuchen($LSC{user_pl}, 'Search&Action2=Team', 3))) {
		my ($Teamname, $UserID) = TeamnameAndUserFromTeamID($TeamID);
		my $User = NameFromUserID($UserID);
		my $owner = $User ? UserLink($User, $UserID) : 'not available';
		print "<b>Informationen zum gewhlten Team:</b>".br;
		print "Team: ".TeamLink($Teamname, $TeamID).br;
		print "Owner: ".$owner.br;
		print br.br;
	}
	
	if (!$Action) {
		print br.br.hr.br;
	}
	my $UserID;
	if ((!$Action || $Action eq "User") && ($UserID=TeamSuchen($LSC{user_pl}, 'Search&Action2=User', 2))) {
		my $User = NameFromUserID($UserID);
		print "<b>Gewhlter User:</b>".br;
		print UserLink($User, $UserID).br;
		print br.br;
	}

	if (!$Action) {
		print br.br.hr.br;
	}
	if (!$Action || $Action eq "WonID") {
		print "<b>$LSC{TEXT}{default}[3] suchen:</b>".br;
		print start_form('post',"$LSC{user_pl}?League=$LSC{League}&Action=Search&Action2=WonID");
		print $q->textfield('WonID','',10)." (mindestens 6 Zeichen) ";
		print submit('submit'),end_form;
		
		if (defined($q->param("WonID"))) {
			if (length($q->param("WonID")) < 6) {
				print "Bitte mindestens 6 Zeichen angeben!".br;
			} elsif ($q->param("WonID") =~ /[^A-Z,a-z,0-9\: ]/) {
				print 'Bitte nur Buchstaben, Zahlen und ":" benutzen!'.br;
			} else {
				my $select	= 'UserID, Login, WonID';
				my $from	= "lsc_user ";
				my $where	= 'WonID like "%'.$q->param("WonID").'%"';
				my $order	= "order by Login";
			
				my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $order");
				$sth->execute();
				print "<b>Gefundene User:</b>".br;
				while (my @ref = $sth->fetchrow_array()) {
					print UserLink($ref[1], $ref[0])." ID: $ref[2]".br;
				}
				$sth->finish;
			}
		}
	}

}
sub TeamFordern {
	Require("LSCErgebnisse2.fordern.pm");
	MSGFordern($LSC{Action2} || 'new', $LSC{special} || $q->param('GefordertesTeam'));
}


sub x {	print $scriptname;}

sub SwitchUserStatus {
	if ($LSC{userid} != 1) {
		print "nicht erlaubt";
		return;
	}
	my $s = $LSC{UserStatus} == 9 ? 1 : 9;
	my $sth = $LSC{MySQL}->do("update lsc_user Set Status=$s where UserID=1");
	print "gendert auf $s".br;

}